(function () {

/* Imports */
var Meteor = Package.meteor.Meteor;
var global = Package.meteor.global;
var meteorEnv = Package.meteor.meteorEnv;
var ECMAScript = Package.ecmascript.ECMAScript;
var MongoInternals = Package.mongo.MongoInternals;
var Mongo = Package.mongo.Mongo;
var Random = Package.random.Random;
var check = Package.check.check;
var Match = Package.check.Match;
var _ = Package.underscore._;
var Accounts = Package['accounts-base'].Accounts;
var HTTP = Package.http.HTTP;
var HTTPInternals = Package.http.HTTPInternals;
var Identicon = Package['sandstorm-identicons'].Identicon;
var meteorInstall = Package.modules.meteorInstall;
var Buffer = Package.modules.Buffer;
var process = Package.modules.process;
var Symbol = Package['ecmascript-runtime'].Symbol;
var Map = Package['ecmascript-runtime'].Map;
var Set = Package['ecmascript-runtime'].Set;
var meteorBabelHelpers = Package['babel-runtime'].meteorBabelHelpers;
var Promise = Package.promise.Promise;

/* Package-scope variables */
var Packages, DevPackages, UserActions, Grains, RoleAssignments, Contacts, Sessions, SignupKeys, ActivityStats, DeleteStats, FileTokens, SpkTokens, ApiTokens, ApiHosts, Notifications, ActivitySubscriptions, StatsTokens, Misc, Settings, Migrations, StaticAssets, AssetUploadTokens, Plans, AppIndex, KeybaseProfiles, FeatureKey, SetupSession, successfulReferralsCount, isAdmin, isAdminById, findAdminUserForToken, matchWildcardHost, makeWildcardHost, getWildcardOrigin, SandstormDb, appName;

var require = meteorInstall({"node_modules":{"meteor":{"sandstorm-db":{"db.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/db.js                                                                                         //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2014 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
// This file defines the database schema.                                                                              // 17
                                                                                                                       //
// Useful for debugging: Set the env variable LOG_MONGO_QUERIES to have the server write every                         // 19
// query it makes, so you can see if it's doing queries too often, etc.                                                // 20
if (Meteor.isServer && process.env.LOG_MONGO_QUERIES) {                                                                // 21
  (function () {                                                                                                       // 21
    var oldFind = Mongo.Collection.prototype.find;                                                                     // 22
    Mongo.Collection.prototype.find = function () {                                                                    // 23
      console.log(this._prefix, arguments);                                                                            // 24
      return oldFind.apply(this, arguments);                                                                           // 25
    };                                                                                                                 // 26
  })();                                                                                                                // 21
}                                                                                                                      // 27
                                                                                                                       //
// Helper so that we don't have to if (Meteor.isServer) before declaring indexes.                                      // 29
if (Meteor.isServer) {                                                                                                 // 30
  Mongo.Collection.prototype.ensureIndexOnServer = Mongo.Collection.prototype._ensureIndex;                            // 31
} else {                                                                                                               // 32
  Mongo.Collection.prototype.ensureIndexOnServer = function () {};                                                     // 33
}                                                                                                                      // 34
                                                                                                                       //
// TODO(soon): Systematically go through this file and add ensureIndexOnServer() as needed.                            // 36
                                                                                                                       //
var collectionOptions = { defineMutationMethods: Meteor.isClient };                                                    // 38
// Set to `true` on the client so that method simulation works. Set to `false` on the server                           // 39
// so that we can be extra certain that all mutations must go through methods.                                         // 40
                                                                                                                       //
// Users = new Mongo.Collection("users");                                                                              // 42
// The users collection is special and can be accessed through `Meteor.users`.                                         // 43
// See https://docs.meteor.com/#/full/meteor_users.                                                                    // 44
//                                                                                                                     // 45
// There are two distinct types of entries in the users collection: identities and accounts. An                        // 46
// identity contains personal profile information and typically includes some intrinsic method for                     // 47
// authenticating as the owner of that information.                                                                    // 48
//                                                                                                                     // 49
// An account is an owner of app actions, grains, contacts, notifications, and payment info.                           // 50
// Each account can have multiple identities linked to it. To log in as an account you must first                      // 51
// authenticate as one of its linked identities.                                                                       // 52
//                                                                                                                     // 53
// Every user contains the following fields:                                                                           // 54
//   _id: Unique string ID. For accounts, this is random. For identities, this is the globally                         // 55
//        stable SHA-256 ID of this identity, hex-encoded.                                                             // 56
//   createdAt: Date when this entry was added to the collection.                                                      // 57
//   lastActive: Date of the user's most recent interaction with this Sandstorm server.                                // 58
//   services: Object containing login data used by Meteor authentication services.                                    // 59
//   expires: Date when this user should be deleted. Only present for demo users.                                      // 60
//   upgradedFromDemo: If present, the date when this user was upgraded from being a demo user.                        // 61
//                     TODO(cleanup): Unlike other dates in our database, this is stored as a number                   // 62
//                     rather than as a Date object. We should fix that.                                               // 63
//   appDemoId: If present and non-null, then the user is a demo user who arrived via an /appdemo/                     // 64
//              link. This field contains the app ID of the app that the user started out demoing.                     // 65
//              Unlike the `expires` field, this field is not cleared when the user upgrades from                      // 66
//              being a demo user.                                                                                     // 67
//   suspended: If this exists, this account/identity is supsended. Both accounts and identities                       // 68
//              can be suspended. After some amount of time, the user will be completely deleted                       // 69
//              and removed from the DB.                                                                               // 70
//              It is an object with fields:                                                                           // 71
//                voluntary: Boolean. This is true if the user initiated it. They will have the                        // 72
//                  chance to still login and reverse the suspension/deletion.                                         // 73
//                admin: The userId of the admin who suspended the account.                                            // 74
//                timestamp: Date object. When the suspension occurred.                                                // 75
//                willDelete: Boolean. If true, this account will be deleted after some time.                          // 76
//                                                                                                                     // 77
// Identity users additionally contain the following fields:                                                           // 78
//   profile: Object containing the data that will be shared with users and grains that come into                      // 79
//            contact with this identity. Includes the following fields:                                               // 80
//       service: String containing the name of this identity's authentication method.                                 // 81
//       name: String containing the chosen display name of the identity.                                              // 82
//       handle: String containing the identity's preferred handle.                                                    // 83
//       picture: _id into the StaticAssets table for the identity's picture. If not present,                          // 84
//                an identicon will be used.                                                                           // 85
//       pronoun: One of "male", "female", "neutral", or "robot".                                                      // 86
//   unverifiedEmail: If present, a string containing an email address specified by the user.                          // 87
//   referredBy: ID of the Account that referred this Identity.                                                        // 88
//                                                                                                                     // 89
// Account users additionally contain the following fields:                                                            // 90
//   loginIdentities: Array of identity objects, each of which may include the following fields.                       // 91
//       id: The globally-stable SHA-256 ID of this identity, hex-encoded.                                             // 92
//   nonloginIdentities: Array of identity objects, of the same form as `loginIdentities`. We use                      // 93
//                       a separate array here so that we can use a Mongo index to enforce the                         // 94
//                       invariant that an identity only be a login identity for a single account.                     // 95
//   primaryEmail: String containing this account's primary email address. Must be a verified adress                   // 96
//                 of one of this account's linked identities. Call SandstormDb.getUserEmails()                        // 97
//                 to do this checking automatically.                                                                  // 98
//   isAdmin: Boolean indicating whether this account is allowed to access the Sandstorm admin panel.                  // 99
//   signupKey: If this is an invited user, then this field contains their signup key.                                 // 100
//   signupNote: If the user was invited through a link, then this field contains the note that the                    // 101
//               inviter admin attached to the key.                                                                    // 102
//   signupEmail: If the user was invited by email, then this field contains the email address that                    // 103
//                the invite was sent to.                                                                              // 104
//   hasCompletedSignup: True if this account has confirmed its profile and agreed to this server's                    // 105
//                       terms of service.                                                                             // 106
//   plan: _id of an entry in the Plans table which determines the user's quota.                                       // 107
//   planBonus: {storage, compute, grains} bonus amounts to add to the user's plan. The payments                       // 108
//              module writes data here; we merely read it. Missing fields should be treated as                        // 109
//              zeroes. Does not yet include referral bonus, which is calculated separately.                           // 110
//              TODO(cleanup): Use for referral bonus too.                                                             // 111
//   storageUsage: Number of bytes this user is currently storing.                                                     // 112
//   payments: Object defined by payments module, if loaded.                                                           // 113
//   dailySentMailCount: Number of emails sent by this user today; used to limit spam.                                 // 114
//   accessRequests: Object containing the following fields; used to limit spam.                                       // 115
//       count: Number of "request access" emails during sent during the current interval.                             // 116
//       resetOn: Date when the count should be reset.                                                                 // 117
//   referredByComplete: ID of the Account that referred this Account. If this is set, we                              // 118
//                        stop writing new referredBy values onto Identities for this account.                         // 119
//   referredCompleteDate: The Date at which the completed referral occurred.                                          // 120
//   referredIdentityIds: List of Identity IDs that this Account has referred. This is used for                        // 121
//                        reliably determining which Identity's names are safe to display.                             // 122
//   experiments: Object where each field is an experiment that the user is in, and each value                         // 123
//           is the parameters for that experiment. Typically, the value simply names which                            // 124
//           experiment group which the user is in, where "control" is one group. If an experiment                     // 125
//           is not listed, then the user should not be considered at all for the purpose of that                      // 126
//           experiment. Each experiment may define a point in time where users not already in the                     // 127
//           experiment may be added to it and assigned to a group (for example, at user creation                      // 128
//           time). Current experiments:                                                                               // 129
//       firstTimeBillingPrompt: Value is "control" or "test". Users are assigned to groups at                         // 130
//               account creation on servers where billing is enabled (i.e. Oasis). Users in the                       // 131
//               test group will see a plan selection dialog and asked to make an explitic choice                      // 132
//               (possibly "free") before they can create grains (but not when opening someone                         // 133
//               else's shared grain). The goal of the experiment is to determine whether this                         // 134
//               prompt scares users away -- and also whether it increases paid signups.                               // 135
//       freeGrainLimit: Value is "control" or or a number indicating the grain limit that the                         // 136
//               user should receive when on the "free" plan, e.g. "Infinity".                                         // 137
//   stashedOldUser: A complete copy of this user from before the accounts/identities migration.                       // 138
//                   TODO(cleanup): Delete this field once we're sure it's safe to do so.                              // 139
                                                                                                                       //
Meteor.users.ensureIndexOnServer("services.google.email", { sparse: 1 });                                              // 141
Meteor.users.ensureIndexOnServer("services.github.emails.email", { sparse: 1 });                                       // 142
Meteor.users.ensureIndexOnServer("services.email.email", { unique: 1, sparse: 1 });                                    // 143
Meteor.users.ensureIndexOnServer("loginIdentities.id", { unique: 1, sparse: 1 });                                      // 144
Meteor.users.ensureIndexOnServer("nonloginIdentities.id", { sparse: 1 });                                              // 145
Meteor.users.ensureIndexOnServer("services.google.id", { unique: 1, sparse: 1 });                                      // 146
Meteor.users.ensureIndexOnServer("services.github.id", { unique: 1, sparse: 1 });                                      // 147
Meteor.users.ensureIndexOnServer("suspended.willDelete", { sparse: 1 });                                               // 148
                                                                                                                       //
// TODO(cleanup): This index is obsolete; delete it.                                                                   // 150
Meteor.users.ensureIndexOnServer("identities.id", { unique: 1, sparse: 1 });                                           // 151
                                                                                                                       //
Packages = new Mongo.Collection("packages", collectionOptions);                                                        // 153
// Packages which are installed or downloading.                                                                        // 154
//                                                                                                                     // 155
// Each contains:                                                                                                      // 156
//   _id:  128-bit prefix of SHA-256 hash of spk file, hex-encoded.                                                    // 157
//   status:  String.  One of "download", "verify", "unpack", "analyze", "ready", "failed", "delete"                   // 158
//   progress:  Float.  -1 = N/A, 0-1 = fractional progress (e.g. download percentage),                                // 159
//       >1 = download byte count.                                                                                     // 160
//   error:  If status is "failed", error message string.                                                              // 161
//   manifest:  If status is "ready", the package manifest.  See "Manifest" in package.capnp.                          // 162
//   appId:  If status is "ready", the application ID string.  Packages representing different                         // 163
//       versions of the same app have the same appId.  The spk tool defines the app ID format                         // 164
//       and can cryptographically verify that a package belongs to a particular app ID.                               // 165
//   shouldCleanup:  If true, a reference to this package was recently dropped, and the package                        // 166
//       collector should at some point check whether there are any other references and, if not,                      // 167
//       delete the package.                                                                                           // 168
//   url:  When status is "download", the URL from which the SPK can be obtained, if provided.                         // 169
//   isAutoUpdated: This package was downloaded as part of an auto-update. We shouldn't clean it up                    // 170
//     even if it has no users.                                                                                        // 171
//   authorPgpKeyFingerprint: Verified PGP key fingerprint (SHA-1, hex, all-caps) of the app                           // 172
//     packager.                                                                                                       // 173
                                                                                                                       //
DevPackages = new Mongo.Collection("devpackages", collectionOptions);                                                  // 175
// List of packages currently made available via the dev tools running on the local machine.                           // 176
// This is normally empty; the only time it is non-empty is when a developer is using the spk tool                     // 177
// on the local machine to publish an under-development app to this server. That should only ever                      // 178
// happen on developers' desktop machines.                                                                             // 179
//                                                                                                                     // 180
// While a dev package is published, it automatically appears as installed by every user of the                        // 181
// server, and it overrides all packages with the same application ID. If any instances of those                       // 182
// packages are currently open, they are killed and reset on publish.                                                  // 183
//                                                                                                                     // 184
// When the dev tool disconnects, the package is automatically unpublished, and any open instances                     // 185
// are again killed and refreshed.                                                                                     // 186
//                                                                                                                     // 187
// Each contains:                                                                                                      // 188
//   _id:  The package ID string (as with Packages._id).                                                               // 189
//   appId: The app ID this package is intended to override (as with Packages.appId).                                  // 190
//   timestamp:  Time when the package was last updated. If this changes while the package is                          // 191
//     published, all running instances are reset. This is used e.g. to reset the app each time                        // 192
//     changes are made to the source code.                                                                            // 193
//   manifest:  The app's manifest, as with Packages.manifest.                                                         // 194
//   mountProc: True if the supervisor should mount /proc.                                                             // 195
                                                                                                                       //
UserActions = new Mongo.Collection("userActions", collectionOptions);                                                  // 197
// List of actions that each user has installed which create new grains.  Each app may install                         // 198
// some number of actions (usually, one).                                                                              // 199
//                                                                                                                     // 200
// Each contains:                                                                                                      // 201
//   _id:  random                                                                                                      // 202
//   userId:  Account ID of the user who has installed this action.                                                    // 203
//   packageId:  Package used to run this action.                                                                      // 204
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 205
//   appTitle:  Same as Packages.findOne(packageId).manifest.appTitle; denormalized so                                 // 206
//       that clients can access it without subscribing to the Packages collection.                                    // 207
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 208
//       searchability.                                                                                                // 209
//   appMarketingVersion:  Human-readable presentation of the app version, e.g. "2.9.17"                               // 210
//   title: JSON-encoded LocalizedText title for this action, e.g.                                                     // 211
//       `{defaultText: "New Spreadsheet"}`.                                                                           // 212
//   nounPhrase: JSON-encoded LocalizedText describing what is created when this action is run.                        // 213
//   command:  Manifest.Command to run this action (see package.capnp).                                                // 214
                                                                                                                       //
Grains = new Mongo.Collection("grains", collectionOptions);                                                            // 216
// Grains belonging to users.                                                                                          // 217
//                                                                                                                     // 218
// Each contains:                                                                                                      // 219
//   _id:  random                                                                                                      // 220
//   packageId:  _id of the package of which this grain is an instance.                                                // 221
//   packageSalt: If present, a random string that will used in session ID generation. This field                      // 222
//       is usually updated when `packageId` is updated, triggering automatic refreshes for                            // 223
//       clients with active sessions.                                                                                 // 224
//   appId:  Same as Packages.findOne(packageId).appId; denormalized for searchability.                                // 225
//   appVersion:  Same as Packages.findOne(packageId).manifest.appVersion; denormalized for                            // 226
//       searchability.                                                                                                // 227
//   userId: The _id of the account that owns this grain.                                                              // 228
//   identityId: The identity with which the owning account prefers to open this grain.                                // 229
//   title:  Human-readable string title, as chosen by the user.                                                       // 230
//   lastUsed:  Date when the grain was last used by a user.                                                           // 231
//   private: If true, then knowledge of `_id` does not suffice to open this grain.                                    // 232
//   cachedViewInfo: The JSON-encoded result of `UiView.getViewInfo()`, cached from the most recent                    // 233
//                   time a session to this grain was opened.                                                          // 234
//   trashed: If present, the Date when this grain was moved to the trash bin. Thirty days after                       // 235
//            this date, the grain will be automatically deleted.                                                      // 236
//   suspended: If true, the owner of this grain has been suspended. They will soon be deleted,                        // 237
//              so treat this grain the same as "trashed". It is denormalized out of Users for ease                    // 238
//              of querying.                                                                                           // 239
//   ownerSeenAllActivity: True if the owner has viewed the grain since the last activity event                        // 240
//       occurred. See also ApiTokenOwner.user.seenAllActivity.                                                        // 241
//   size: On-disk size of the grain in bytes.                                                                         // 242
//                                                                                                                     // 243
// The following fields *might* also exist. These are temporary hacks used to implement e-mail and                     // 244
// web publishing functionality without powerbox support; they will be replaced once the powerbox                      // 245
// is implemented.                                                                                                     // 246
//   publicId:  An id used to publicly identify this grain. Used e.g. to route incoming e-mail and                     // 247
//       web publishing. This field is initialized when first requested by the app.                                    // 248
                                                                                                                       //
Grains.ensureIndexOnServer("cachedViewInfo.matchRequests.tags.id", { sparse: 1 });                                     // 250
                                                                                                                       //
RoleAssignments = new Mongo.Collection("roleAssignments", collectionOptions);                                          // 252
// *OBSOLETE* Before `user` was a variant of ApiTokenOwner, this collection was used to store edges                    // 253
// in the permissions sharing graph. This functionality has been subsumed by the ApiTokens                             // 254
// collection.                                                                                                         // 255
                                                                                                                       //
Contacts = new Mongo.Collection("contacts", collectionOptions);                                                        // 257
// Edges in the social graph.                                                                                          // 258
//                                                                                                                     // 259
// If Alice has Bob as a contact, then she is allowed to see Bob's profile information and Bob                         // 260
// will show up in her user-picker UI for actions like share-by-identity.                                              // 261
//                                                                                                                     // 262
// Contacts are not symmetric. Bob might be one of Alice's contacts even if Alice is not one of                        // 263
// Bob's.                                                                                                              // 264
//                                                                                                                     // 265
// Each contains:                                                                                                      // 266
//   _id: random                                                                                                       // 267
//   ownerId: The accountId of the user account who owns this contact.                                                 // 268
//   petname: Human-readable label chosen by and only visible to the owner. Uniquely identifies                        // 269
//            the contact to the owner.                                                                                // 270
//   created: Date when this contact was created.                                                                      // 271
//   identityId: The `_id` of the user whose contact info this contains.                                               // 272
                                                                                                                       //
Sessions = new Mongo.Collection("sessions", collectionOptions);                                                        // 274
// UI sessions open to particular grains.  A new session is created each time a user opens a grain.                    // 275
//                                                                                                                     // 276
// Each contains:                                                                                                      // 277
//   _id:  String generated as a SHA256 hash of the grain ID, the user ID, a salt generated by the                     // 278
//       client, and the grain's `packageSalt`.                                                                        // 279
//   grainId:  _id of the grain to which this session is connected.                                                    // 280
//   hostId: ID part of the hostname from which this grain is being served. I.e. this replaces the                     // 281
//       '*' in WILDCARD_HOST.                                                                                         // 282
//   tabId: Random value unique to the grain tab in which this session is displayed. Typically                         // 283
//       every session has a different `tabId`, but embedded sessions (including in the powerbox)                      // 284
//       have the same `tabId` as the outer session.                                                                   // 285
//   timestamp:  Time of last keep-alive message to this session.  Sessions time out after some                        // 286
//       period.                                                                                                       // 287
//   userId:  Account ID of the user who owns this session.                                                            // 288
//   identityId:  Identity ID of the user who owns this session.                                                       // 289
//   hashedToken: If the session is owned by an anonymous user, the _id of the entry in ApiTokens                      // 290
//       that was used to open it. Note that for old-style sharing (i.e. when !grain.private),                         // 291
//       anonymous users can get access without an API token and so neither userId nor hashedToken                     // 292
//       are present.                                                                                                  // 293
//   powerboxView: Information about a server-initiated powerbox interaction taking place in this                      // 294
//       session. When the client sees a `powerboxView` appear on the session, it opens the                            // 295
//       powerbox popup according to the contents. This field is an object containing one of:                          // 296
//     offer: A capability is being offered to the user by the app. This is an object containing:                      // 297
//       token: For a non-UiView capability, the API token that can be used to restore this                            // 298
//           capability.                                                                                               // 299
//       uiView: A UiView capability. This object contains one of:                                                     // 300
//         tokenId: The _id of an ApiToken belonging to the current user.                                              // 301
//         token: A full webkey token which can be opened by an anonymous user.                                        // 302
//     fulfill: A capability is being offered which fulfills the active powerbox request. This                         // 303
//         is an object with members:                                                                                  // 304
//       token: The SturdyRef of the fulfilling capability. This token can only be used in a call                      // 305
//           to claimRequest() by the requesting                                                                       // 306
//           grain.                                                                                                    // 307
//       descriptor: Packed-base64 PowerboxDescriptor for the capability.                                              // 308
//   powerboxRequest: If present, this session is a powerbox request session. Object containing:                       // 309
//     descriptors: Array of PowerboxDescriptors representing the request.                                             // 310
//     requestingSession: Session ID of the session initiating the request.                                            // 311
//   viewInfo: The UiView.ViewInfo corresponding to the underlying UiSession. This isn't populated                     // 312
//       until newSession is called on the UiView.                                                                     // 313
//   permissions: The permissions for the current identity on this UiView. This isn't populated                        // 314
//       until newSession is called on the UiView.                                                                     // 315
//   hasLoaded: Marked as true by the proxy when the underlying UiSession has responded to its first                   // 316
//       request                                                                                                       // 317
                                                                                                                       //
SignupKeys = new Mongo.Collection("signupKeys", collectionOptions);                                                    // 319
// Invite keys which may be used by users to get access to Sandstorm.                                                  // 320
//                                                                                                                     // 321
// Each contains:                                                                                                      // 322
//   _id:  random                                                                                                      // 323
//   used:  Boolean indicating whether this key has already been consumed.                                             // 324
//   note:  Text note assigned when creating key, to keep track of e.g. whom the key was for.                          // 325
//   email: If this key was sent as an email invite, the email address to which it was sent.                           // 326
                                                                                                                       //
ActivityStats = new Mongo.Collection("activityStats", collectionOptions);                                              // 328
// Contains usage statistics taken on a regular interval. Each entry is a data point.                                  // 329
//                                                                                                                     // 330
// Each contains:                                                                                                      // 331
//   timestamp: Date when measurements were taken.                                                                     // 332
//   daily: Contains stats counts pertaining to the last day before the sample time.                                   // 333
//   weekly: Contains stats counts pertaining to the last seven days before the sample time.                           // 334
//   monthly: Contains stats counts pertaining to the last thirty days before the timestamp.                           // 335
//                                                                                                                     // 336
// Each of daily, weekly, and monthly contains:                                                                        // 337
//   activeUsers: The number of unique users who have used a grain on the server in the time                           // 338
//       interval. Only counts logged-in users.                                                                        // 339
//   demoUsers: Demo users.                                                                                            // 340
//   appDemoUsers: Users that came in through "app demo".                                                              // 341
//   activeGrains: The number of unique grains that have been used in the time interval.                               // 342
//   apps: An object indexed by app ID recording, for each app:                                                        // 343
//       owners: Number of unique owners of this app (counting only grains that still exist).                          // 344
//       sharedUsers: Number of users who have accessed other people's grains of this app (counting                    // 345
//         only grains that still exist).                                                                              // 346
//       grains: Number of active grains of this app (that still exist).                                               // 347
//       deleted: Number of non-demo grains of this app that were deleted.                                             // 348
//       demoed: Number of demo grains created and expired.                                                            // 349
//       appDemoUsers: Number of app demos initiated with this app.                                                    // 350
                                                                                                                       //
DeleteStats = new Mongo.Collection("deleteStats", collectionOptions);                                                  // 352
// Contains records of objects that were deleted, for stat-keeping purposes.                                           // 353
//                                                                                                                     // 354
// Each contains:                                                                                                      // 355
//   type: "grain" or "user" or "demoGrain" or "demoUser" or "appDemoUser"                                             // 356
//   lastActive: Date of the user's or grain's last activity.                                                          // 357
//   appId: For type = "grain", the app ID of the grain. For type = "appDemoUser", the app ID they                     // 358
//     arrived to demo. For others, undefined.                                                                         // 359
//   experiments: The experiments the user (or owner of the grain) was in. See user.experiments.                       // 360
                                                                                                                       //
FileTokens = new Mongo.Collection("fileTokens", collectionOptions);                                                    // 362
// Tokens corresponding to backup files that are currently stored on the server. A user receives                       // 363
// a token when they create a backup file (either by uploading it, or by backing up one of their                       // 364
// grains) and may use the token to read the file (either to download it, or to restore a new                          // 365
// grain from it).                                                                                                     // 366
//                                                                                                                     // 367
// Each contains:                                                                                                      // 368
//   _id:       The unguessable token string.                                                                          // 369
//   name:      Suggested filename.                                                                                    // 370
//   timestamp: File creation time. Used to figure out when the token and file should be wiped.                        // 371
                                                                                                                       //
SpkTokens = new Mongo.Collection("spkTokens", collectionOptions);                                                      // 373
// A lot like FileTokens, but for SPK uploads.                                                                         // 374
//                                                                                                                     // 375
// Each contains:                                                                                                      // 376
//   _id:       The unguessable token string.                                                                          // 377
//   timestamp: Creation time. Used to figure out when the token should be wiped.                                      // 378
                                                                                                                       //
ApiTokens = new Mongo.Collection("apiTokens", collectionOptions);                                                      // 380
// Access tokens for APIs exported by apps.                                                                            // 381
//                                                                                                                     // 382
// Originally API tokens were only used by external users through the HTTP API endpoint. However,                      // 383
// now they are also used to implement SturdyRefs, not just held by external users, but also when                      // 384
// an app holds a SturdyRef to another app within the same server. See the various `save()`,                           // 385
// `restore()`, and `drop()` methods in `grain.capnp` (on `SandstormApi`, `AppPersistent`, and                         // 386
// `MainView`) -- the fields of type `Data` are API tokens.                                                            // 387
//                                                                                                                     // 388
// Each contains:                                                                                                      // 389
//   _id:       A SHA-256 hash of the token, base64-encoded.                                                           // 390
//   grainId:   The grain servicing this API. (Not present if the API isn't serviced by a grain.)                      // 391
//   identityId: For UiView capabilities, this is the identity for which the view is attenuated.                       // 392
//              That is, the UiView's newSession() method will intersect the requested permissions                     // 393
//              with this identity's permissions before forwarding on to the underlying app. If                        // 394
//              `identityId` is not present, then no identity attenuation is applied, i.e. this is                     // 395
//              a raw UiView as implemented by the app. (The `roleAssignment` field, below, may                        // 396
//              still apply. For non-UiView capabilities, `identityId` is never present. Note that                     // 397
//              this is NOT the identity against which the `requiredPermissions` parameter of                          // 398
//              `SandstormApi.restore()` is checked; that would be `owner.grain.introducerIdentity`.                   // 399
//   accountId: For tokens where `identityId` is set, the `_id` (in the Users table) of the account                    // 400
//              that created the token.                                                                                // 401
//   roleAssignment: If this API token represents a UiView, this field contains a JSON-encoded                         // 402
//              Grain.ViewSharingLink.RoleAssignment representing the permissions it carries. These                    // 403
//              permissions will be intersected with those held by `identityId` when the view is                       // 404
//              opened.                                                                                                // 405
//   forSharing: If true, requests sent to the HTTP API endpoint with this token will be treated as                    // 406
//              anonymous rather than as directly associated with `identityId`. This has no effect                     // 407
//              on the permissions granted.                                                                            // 408
//   objectId:  If present, this token represents an arbitrary Cap'n Proto capability exported by                      // 409
//              the app or its supervisor (whereas without this it strictly represents UiView).                        // 410
//              sturdyRef is the JSON-encoded SupervisorObjectId (defined in `supervisor.capnp`).                      // 411
//              Note that if the SupervisorObjectId contains an AppObjectId, that field is                             // 412
//              treated as type AnyPointer, and so encoded as a raw Cap'n Proto message.                               // 413
//   frontendRef: If present, this token actually refers to an object implemented by the front-end,                    // 414
//              not a particular grain. (`grainId` and `identityId` are not set.) This is an object                    // 415
//              containing exactly one of the following fields:                                                        // 416
//       notificationHandle: A `Handle` for an ongoing notification, as returned by                                    // 417
//                           `NotificationTarget.addOngoing`. The value is an `_id` from the                           // 418
//                           `Notifications` collection.                                                               // 419
//       ipNetwork: An IpNetwork capability that is implemented by the frontend. Eventually, this                      // 420
//                  will be moved out of the frontend and into the backend, but we'll migrate the                      // 421
//                  database when that happens. This field contains the boolean true to signify that                   // 422
//                  it has been set.                                                                                   // 423
//       ipInterface: Ditto IpNetwork, except it's an IpInterface.                                                     // 424
//       emailVerifier: An EmailVerifier capability that is implemented by the frontend. The                           // 425
//                      value is an object containing the fields `id` and `services`. `id` is the                      // 426
//                      value returned by `EmailVerifier.getId()` and is used as part of a                             // 427
//                      powerbox query for matching verified emails. `services` is a                                   // 428
//                      list of names of identity providers that are trusted to verify addresses.                      // 429
//                      If `services` is omitted or falsy, all configured identity providers are                       // 430
//                      trusted. Note that a malicious user could specify invalid names in the                         // 431
//                      list; they should be ignored.                                                                  // 432
//       verifiedEmail: An VerifiedEmail capability that is implemented by the frontend.                               // 433
//                      An object containing `verifierId`, `tabId`, and `address`.                                     // 434
//       identity: An Identity capability. The field is the identity ID.                                               // 435
//       http: An ApiSession capability pointing to an external HTTP service. Object containing:                       // 436
//           url: Base URL of the external service.                                                                    // 437
//           auth: Authentication mechanism. Object containing one of:                                                 // 438
//               none: Value "null". Indicates no authorization.                                                       // 439
//               bearer: A bearer token to pass in the `Authorization: Bearer` header on all                           // 440
//                   requests. Encrypted with nonce 0.                                                                 // 441
//               basic: A `{username, password}` object. The password is encrypted with nonce 0.                       // 442
//                   Before encryption, the password is padded to 32 bytes by appending NUL bytes,                     // 443
//                   in order to mask the length of small passwords.                                                   // 444
//               refresh: An OAuth refresh token, which can be exchanged for an access token.                          // 445
//                   Encrypted with nonce 0.                                                                           // 446
//               TODO(security): How do we protect URLs that directly embed their secret? We don't                     // 447
//                   want to encrypt the full URL since this would make it hard to show a                              // 448
//                   meaningful audit UI, but maybe we could figure out a way to extract the key                       // 449
//                   part and encrypt it separately?                                                                   // 450
//   parentToken: If present, then this token represents exactly the capability represented by                         // 451
//              the ApiToken with _id = parentToken, except possibly (if it is a UiView) attenuated                    // 452
//              by `roleAssignment` (if present). To facilitate permissions computations, if the                       // 453
//              capability is a UiView, then `grainId` is set to the backing grain, `identityId`                       // 454
//              is set to the identity that shared the view, and `accountId` is set to the account                     // 455
//              that shared the view. Neither `objectId` nor `frontendRef` is present when                             // 456
//              `parentToken` is present.                                                                              // 457
//   parentTokenKey: The actual parent token -- whereas `parentToken` is only the parent token ID                      // 458
//              (hash). `parentTokenFull` is encrypted with nonce 0 (see below). This is needed                        // 459
//              in particular when the parent contains encrypted fields, since those would need to                     // 460
//              be decrypted using this key. If the parent contains no encrypted fields then                           // 461
//              `parentTokenKey` may be omitted from the child.                                                        // 462
//   petname:   Human-readable label for this access token, useful for identifying tokens for                          // 463
//              revocation. This should be displayed when visualizing incoming capabilities to                         // 464
//              the grain identified by `grainId`.                                                                     // 465
//   created:   Date when this token was created.                                                                      // 466
//   revoked:   If true, then this sturdyref has been revoked and can no longer be restored. It may                    // 467
//              become un-revoked in the future.                                                                       // 468
//   trashed:   If present, the Date when this token was moved to the trash bin. Thirty days after                     // 469
//              this date, the token will be automatically deleted.                                                    // 470
//   suspended: If true, the owner of this token has been suspended. They will soon be deleted,                        // 471
//              so treat this token the same as "trashed". It is denormalized out of Users for                         // 472
//              ease of querying.                                                                                      // 473
//   expires:   Optional expiration Date. If undefined, the token does not expire.                                     // 474
//   lastUsed:  Optional Date when this token was last used.                                                           // 475
//   owner:     A `ApiTokenOwner` (defined in `supervisor.capnp`, stored as a JSON object)                             // 476
//              as passed to the `save()` call that created this token. If not present, treat                          // 477
//              as `webkey` (the default for `ApiTokenOwner`).                                                         // 478
//   expiresIfUnused:                                                                                                  // 479
//              Optional Date after which the token, if it has not been used yet, expires.                             // 480
//              This field should be cleared on a token's first use.                                                   // 481
//   requirements: List of conditions which must hold for this token to be considered valid.                           // 482
//              Semantically, this list specifies the powers which were *used* to originally                           // 483
//              create the token. If any condition in the list becomes untrue, then the token must                     // 484
//              be considered revoked, and all live refs and sturdy refs obtained transitively                         // 485
//              through it must also become revoked. Each item is the JSON serialization of the                        // 486
//              `MembraneRequirement` structure defined in `supervisor.capnp`.                                         // 487
//   hasApiHost: If true, there is an entry in ApiHosts for this token, which will need to be                          // 488
//              cleaned up when the token is.                                                                          // 489
//                                                                                                                     // 490
// It is important to note that a token's owner and provider are independent from each other. To                       // 491
// illustrate, here is an approximate definition of ApiToken in pseudo Cap'n Proto schema language:                    // 492
//                                                                                                                     // 493
// struct ApiToken {                                                                                                   // 494
//   owner :ApiTokenOwner;                                                                                             // 495
//   provider :union {                                                                                                 // 496
//     grain :group {                                                                                                  // 497
//       grainId :Text;                                                                                                // 498
//       union {                                                                                                       // 499
//         uiView :group {                                                                                             // 500
//           identityId :Text;                                                                                         // 501
//           roleAssignment :RoleAssignment;                                                                           // 502
//           forSharing :Bool;                                                                                         // 503
//         }                                                                                                           // 504
//         objectId :SupervisorObjectId;                                                                               // 505
//       }                                                                                                             // 506
//     }                                                                                                               // 507
//     frontendRef :union {                                                                                            // 508
//       notificationHandle :Text;                                                                                     // 509
//       ipNetwork :Bool;                                                                                              // 510
//       ipInterface :Bool;                                                                                            // 511
//       emailVerifier :group {                                                                                        // 512
//         id :Text;                                                                                                   // 513
//         services :List(String);                                                                                     // 514
//       }                                                                                                             // 515
//       verifiedEmail :group {                                                                                        // 516
//         verifierId :Text;                                                                                           // 517
//         tabId :Text;                                                                                                // 518
//         address :Text;                                                                                              // 519
//       }                                                                                                             // 520
//       identity :Text;                                                                                               // 521
//       http :group {                                                                                                 // 522
//         url :Text;                                                                                                  // 523
//         auth :union {                                                                                               // 524
//           none :Void;                                                                                               // 525
//           bearer :Text;                                                                                             // 526
//           basic :group { username :Text; password :Text; }                                                          // 527
//           refresh :Text;                                                                                            // 528
//         }                                                                                                           // 529
//       }                                                                                                             // 530
//     }                                                                                                               // 531
//     child :group {                                                                                                  // 532
//       parentToken :Text;                                                                                            // 533
//       union {                                                                                                       // 534
//         uiView :group {                                                                                             // 535
//           grainId :Text;                                                                                            // 536
//           identityId :Text;                                                                                         // 537
//           roleAssignment :RoleAssignment = (allAccess = ());                                                        // 538
//         }                                                                                                           // 539
//         other :Void;                                                                                                // 540
//       }                                                                                                             // 541
//     }                                                                                                               // 542
//   }                                                                                                                 // 543
//   requirements: List(Supervisor.MembraneRequirement);                                                               // 544
//   ...                                                                                                               // 545
// }                                                                                                                   // 546
//                                                                                                                     // 547
// ENCRYPTION                                                                                                          // 548
//                                                                                                                     // 549
// We want to make sure that someone who obtains a copy of the database cannot use it to gain live                     // 550
// credentials.                                                                                                        // 551
//                                                                                                                     // 552
// The actual token corresponding to an ApiToken entry is not stored in the entry itself. Instead,                     // 553
// the ApiToken's `_id` is constructed as a SHA256 hash of the actual token. To use an ApiToken                        // 554
// in the live system, you must present the original token.                                                            // 555
//                                                                                                                     // 556
// Additionally, some ApiToken entries contain tokens to third-party services, e.g. OAuth tokens                       // 557
// or even passwords. Such tokens are encrypted, using the ApiToken entry's own full token (which,                     // 558
// again, is not stored in the database) as the encryption key.                                                        // 559
//                                                                                                                     // 560
// When such encryption is applied, the cipher used is ChaCha20. All API tokens are 256-bit base64                     // 561
// strings, hence can be used directly as the key. No MAC is applied, because this scheme is not                       // 562
// intended to protect against attackers who have write access to the database -- such an attacker                     // 563
// could almost certainly do more damage by modifying the non-encrypted fields anyway. (Put another                    // 564
// way, if we wanted to MAC something, we'd need to MAC the entire ApiToken structure, not just                        // 565
// the encrypted key. But we don't have a way to do that at present.)                                                  // 566
//                                                                                                                     // 567
// ChaCha20 requires a nonce. Luckily, all of the fields we wish to encrypt are immutable, so we                       // 568
// don't have to worry about tracking nonces over time -- we can just assign a static nonce to each                    // 569
// field. Moreover, many (currently, all) of these fields are mutually exclusive, so can even share                    // 570
// nonces. Currently, nonces map to fields as follows:                                                                 // 571
//                                                                                                                     // 572
// nonce 0:                                                                                                            // 573
//     parentTokenKey                                                                                                  // 574
//     frontendRef.http.auth.basic.password                                                                            // 575
//     frontendRef.http.auth.bearer                                                                                    // 576
//     frontendRef.http.auth.refresh                                                                                   // 577
                                                                                                                       //
ApiTokens.ensureIndexOnServer("grainId", { sparse: 1 });                                                               // 579
ApiTokens.ensureIndexOnServer("owner.user.identityId", { sparse: 1 });                                                 // 580
ApiTokens.ensureIndexOnServer("frontendRef.emailVerifier.id", { sparse: 1 });                                          // 581
                                                                                                                       //
ApiHosts = new Mongo.Collection("apiHosts", collectionOptions);                                                        // 583
// Allows defining some limited static behavior for an API host when accessed unauthenticated. This                    // 584
// mainly exists to allow backwards-compatibility with client applications that expect to be able                      // 585
// to probe an API host without authentication to determine capabilities such as DAV protocols                         // 586
// supported, before authenticating to perform real requests. An app can specify these properties                      // 587
// when creating an offerTemplate.                                                                                     // 588
//                                                                                                                     // 589
// Each contains:                                                                                                      // 590
//   _id:          apiHostIdHashForToken() of the corresponding API token.                                             // 591
//   hash2:        hash(hash(token)), aka hash(ApiToken._id). Used to allow ApiHosts to be cleaned                     // 592
//                 up when ApiTokens are deleted.                                                                      // 593
//   options:      Specifies how to respond to unauthenticated OPTIONS requests on this host.                          // 594
//                 This is an object containing fields:                                                                // 595
//     dav:        List of strings specifying DAV header `compliance-class`es, e.g. "1" or                             // 596
//                 "calendar-access". https://tools.ietf.org/html/rfc4918#section-10.1                                 // 597
//   resources:    Object mapping URL paths (including initial '/') to static HTTP responses to                        // 598
//                 give when those paths are accessed unauthenticated. Due to Mongo disliking '.'                      // 599
//                 and '$' in keys, these characters must be escaped as '\uFF0E' and '\uFF04'                          // 600
//                 (see SandstormDb.escapeMongoKey). Each value in this map is an object with                          // 601
//                 fields:                                                                                             // 602
//     type:       Content-Type.                                                                                       // 603
//     language:   Content-Language.                                                                                   // 604
//     encoding:   Content-Encoding.                                                                                   // 605
//     body:       Entity-body as a string or buffer.                                                                  // 606
                                                                                                                       //
Notifications = new Mongo.Collection("notifications", collectionOptions);                                              // 608
// Notifications for a user.                                                                                           // 609
//                                                                                                                     // 610
// Each contains:                                                                                                      // 611
//   _id:          random                                                                                              // 612
//   grainId:      The grain originating this notification, if any.                                                    // 613
//   userId:       Account ID of the user receiving the notification.                                                  // 614
//   text:         The JSON-ified LocalizedText to display in the notification.                                        // 615
//   isUnread:     Boolean indicating if this notification is unread.                                                  // 616
//   timestamp:    Date when this notification was last updated                                                        // 617
//   eventType:    If this notification is due to an activity event, this is the numeric index                         // 618
//                 of the event type on the grain's ViewInfo.                                                          // 619
//   count:        The number of times this exact event has repeated. Identical events are                             // 620
//                 aggregated by incrementing the count.                                                               // 621
//   initiatingIdentity: Identity ID of the user who initiated this notification.                                      // 622
//   initiatorAnonymous: True if the initiator is an anonymous user. If neither this nor                               // 623
//                 initiatingIdentity is present, the notification is not from a user.                                 // 624
//   path:         Path inside the grain to which the user should be directed if they click on                         // 625
//                 the notification.                                                                                   // 626
//   ongoing:      If present, this is an ongoing notification, and this field contains an                             // 627
//                 ApiToken referencing the `OngoingNotification` capability.                                          // 628
//   admin:        If present, this is a notification intended for an admin.                                           // 629
//     action:     If present, this is a (string) link that the notification should direct the                         // 630
//                 admin to.                                                                                           // 631
//     type:       The type of notification -- currently can only be "reportStats".                                    // 632
//   appUpdates:   If present, this is an app update notification. It is an object with the appIds                     // 633
//                 as keys.                                                                                            // 634
//     $appId:     The appId that has an outstanding update.                                                           // 635
//       packageId: The packageId that it will update to.                                                              // 636
//       name: The name of the app. (appTitle from package.manifest)                                                   // 637
//       version: The app's version number. (appVersion from package.manifest)                                         // 638
//       marketingVersion: String marketing version of this app. (appMarketingVersion from package.manifest)           // 639
//   referral:     If this boolean field is true, then treat this notification as a referral                           // 640
//                 notification. This causes text to be ignored, since we need custom logic.                           // 641
//   mailingListBonus: Like `referral`, but notify the user about the mailing list bonus. This is                      // 642
//                 a one-time notification only to Oasis users who existed when the bonus program                      // 643
//                 was implemented.                                                                                    // 644
                                                                                                                       //
ActivitySubscriptions = new Mongo.Collection("activitySubscriptions", collectionOptions);                              // 646
// Activity events to which a user is subscribed.                                                                      // 647
//                                                                                                                     // 648
// Each contains:                                                                                                      // 649
//   _id:          random                                                                                              // 650
//   identityId:   Who is subscribed.                                                                                  // 651
//   grainId:      Grain to which subscription applies.                                                                // 652
//   threadPath:   If present, the subscription is on a specific thread. Otherwise, it is on the                       // 653
//                 whole grain.                                                                                        // 654
//   mute:         If true, this is an anti-subscription -- matching events should NOT notify.                         // 655
//                 This allows is useful to express:                                                                   // 656
//                 - A user wants to subscribe to a grain but mute a specific thread.                                  // 657
//                 - The owner of a grain does not want notifications (normally, they are                              // 658
//                   implicitly subscribed).                                                                           // 659
//                 - A user no longer wishes to be implicitly subscribed to threads in a grain on                      // 660
//                   which they comment, so they mute the grain.                                                       // 661
                                                                                                                       //
ActivitySubscriptions.ensureIndexOnServer("identityId");                                                               // 663
ActivitySubscriptions.ensureIndexOnServer({ "grainId": 1, "threadPath": 1 });                                          // 664
                                                                                                                       //
StatsTokens = new Mongo.Collection("statsTokens", collectionOptions);                                                  // 666
// Access tokens for the Stats collection                                                                              // 667
//                                                                                                                     // 668
// These tokens are used for accessing the ActivityStats collection remotely                                           // 669
// (ie. from a dashboard webapp)                                                                                       // 670
//                                                                                                                     // 671
// Each contains:                                                                                                      // 672
//   _id:       The token. At least 128 bits entropy (Random.id(22)).                                                  // 673
                                                                                                                       //
Misc = new Mongo.Collection("misc", collectionOptions);                                                                // 675
// Miscellaneous configuration and other settings                                                                      // 676
//                                                                                                                     // 677
// This table is currently only used for persisting BASE_URL from one session to the next,                             // 678
// but in general any miscellaneous settings should go in here                                                         // 679
//                                                                                                                     // 680
// Each contains:                                                                                                      // 681
//   _id:       The name of the setting. eg. "BASE_URL"                                                                // 682
//   value:     The value of the setting.                                                                              // 683
                                                                                                                       //
Settings = new Mongo.Collection("settings", collectionOptions);                                                        // 685
// Settings for this Sandstorm instance go here. They are configured through the adminSettings                         // 686
// route. This collection differs from misc in that any admin user can update it through the admin                     // 687
// interface.                                                                                                          // 688
//                                                                                                                     // 689
// Each contains:                                                                                                      // 690
//   _id:       The name of the setting. eg. "smtpConfig"                                                              // 691
//   value:     The value of the setting.                                                                              // 692
//   automaticallyReset: Sometimes the server needs to automatically reset a setting. When it does                     // 693
//                       so, it will also write an object to this field indicating why the reset was                   // 694
//                       needed. That object can have the following variants:                                          // 695
//       baseUrlChangedFrom: The reset was due to BASE_URL changing. This field contains a string                      // 696
//                           with the old BASE_URL.                                                                    // 697
//   preinstalledApps: A list of objects:                                                                              // 698
//     appId: The Packages.appId of the app to install                                                                 // 699
//     status: packageId                                                                                               // 700
//     packageId: The Packages._id of the app to install                                                               // 701
//                                                                                                                     // 702
//   potentially other fields that are unique to the setting                                                           // 703
                                                                                                                       //
Migrations = new Mongo.Collection("migrations", collectionOptions);                                                    // 705
// This table tracks which migrations we have applied to this instance.                                                // 706
// It contains a single entry:                                                                                         // 707
//   _id:       "migrations_applied"                                                                                   // 708
//   value:     The number of migrations this instance has successfully completed.                                     // 709
                                                                                                                       //
StaticAssets = new Mongo.Collection("staticAssets", collectionOptions);                                                // 711
// Collection of static assets served up from the Sandstorm server's "static" host. We only                            // 712
// support relatively small assets: under 1MB each.                                                                    // 713
//                                                                                                                     // 714
// Each contains:                                                                                                      // 715
//   _id:       Random ID; will be used in the URL.                                                                    // 716
//   hash:      A base64-encoded SHA-256 hash of the data, used to de-dupe.                                            // 717
//   mimeType:  MIME type of the asset, suitable for Content-Type header.                                              // 718
//   encoding:  Either "gzip" or not present, suitable for Content-Encoding header.                                    // 719
//   content:   The asset content (byte buffer).                                                                       // 720
//   refcount:  Number of places where this asset's ID appears in the database. Since Mongo doesn't                    // 721
//       have transactions, this needs to bias towards over-counting; a backup GC could be used                        // 722
//       to catch leaked assets, although it's probably not a big deal in practice.                                    // 723
                                                                                                                       //
AssetUploadTokens = new Mongo.Collection("assetUploadTokens", collectionOptions);                                      // 725
// Collection of tokens representing a single-use permission to upload an asset, such as a new                         // 726
// profile picture.                                                                                                    // 727
//                                                                                                                     // 728
// Each contains:                                                                                                      // 729
//   _id:       Random ID.                                                                                             // 730
//   purpose:   Contains one of the following, indicating how the asset is to be used:                                 // 731
//       profilePicture: Indicates that the upload is a new profile picture. Contains fields:                          // 732
//           userId: Account ID of user whose picture shall be replaced.                                               // 733
//           identityId: Which of the user's identities shall be updated.                                              // 734
//   expires:   Time when this token will go away if unused.                                                           // 735
                                                                                                                       //
Plans = new Mongo.Collection("plans", collectionOptions);                                                              // 737
// Subscription plans, which determine quota.                                                                          // 738
//                                                                                                                     // 739
// Each contains:                                                                                                      // 740
//   _id: Plan ID, usually a short string like "free", "standard", "large", "mega", ...                                // 741
//   storage: Number of bytes this user is allowed to store.                                                           // 742
//   compute: Number of kilobyte-RAM-seconds this user is allowed to consume.                                          // 743
//   computeLabel: Label to display to the user describing this plan's compute units.                                  // 744
//   grains: Total number of grains this user can create (often `Infinity`).                                           // 745
//   price: Price per month in US cents.                                                                               // 746
//   hidden: If true, a user cannot switch to this plan, but some users may be on it and are                           // 747
//       allowed to switch away.                                                                                       // 748
//   title: Title from display purposes. If missing, default to capitalizing _id.                                      // 749
                                                                                                                       //
AppIndex = new Mongo.Collection("appIndex", collectionOptions);                                                        // 751
// A mirror of the data from the App Market index                                                                      // 752
//                                                                                                                     // 753
// Each contains:                                                                                                      // 754
//   _id: the appId of the app                                                                                         // 755
//  The rest of the fields are defined in src/sandstorm/app-index/app-index.capnp:AppIndexForMarket                    // 756
                                                                                                                       //
KeybaseProfiles = new Mongo.Collection("keybaseProfiles", collectionOptions);                                          // 758
// Cache of Keybase profile information. The profile for a user is re-fetched every time a package                     // 759
// by that user is installed, as well as if the keybase profile is requested and not already                           // 760
// present for some reason.                                                                                            // 761
//                                                                                                                     // 762
// Each contains:                                                                                                      // 763
//   _id: PGP key fingerprint (SHA-1, hex, all-caps)                                                                   // 764
//   displayName: Display name from Keybase. (NOT VERIFIED AT ALL.)                                                    // 765
//   handle: Keybase handle.                                                                                           // 766
//   proofs: The "proofs_summary.all" array from the Keybase lookup. See the non-existent Keybase                      // 767
//     docs for details. We also add a boolean "status" field to each proof indicating whether                         // 768
//     we have directly verified the proof ourselves. Its values may be "unverified" (Keybase                          // 769
//     returned this but we haven't checked it directly), "verified" (we verified the proof and it                     // 770
//     is valid), "invalid" (we checked the proof and it was definitely bogus), or "checking" (the                     // 771
//     server is currently actively checking this proof). Note that if a check fails due to network                    // 772
//     errors, the status goes back to "unverified".                                                                   // 773
//                                                                                                                     // 774
//     WARNING: Currently verification is NOT IMPLEMENTED, so all proofs will be "unverified"                          // 775
//       for now and we just trust Keybase.                                                                            // 776
                                                                                                                       //
FeatureKey = new Mongo.Collection("featureKey", collectionOptions);                                                    // 778
// OBSOLETE: This was used to implement the Sandstorm for Work paywall, which has been removed.                        // 779
//   Collection object still defined because it could have old data in it, for servers that used                       // 780
//   to have a feature key.                                                                                            // 781
                                                                                                                       //
SetupSession = new Mongo.Collection("setupSession", collectionOptions);                                                // 783
// Responsible for storing information about setup sessions.  Contains a single document with three                    // 784
// keys:                                                                                                               // 785
//                                                                                                                     // 786
//   _id: "current-session"                                                                                            // 787
//   creationDate: Date object indicating when this session was created.                                               // 788
//   hashedSessionId: the sha256 of the secret session id that was returned to the client                              // 789
                                                                                                                       //
var DesktopNotifications = new Mongo.Collection("desktopNotifications", collectionOptions);                            // 791
// Responsible for very short-lived queueing of desktop notification information.                                      // 792
// Entries are removed when they are ~30 seconds old.  This collection is a bit                                        // 793
// odd in that it is intended primarily for edge-triggered communications, but                                         // 794
// Meteor's collections aren't really designed to support that organization.                                           // 795
// Fields for each :                                                                                                   // 796
//                                                                                                                     // 797
//   _id: String.  Used as the tag to coordinate notification merging between browser tabs.                            // 798
//   creationDate: Date object. indicating when this notification was posted.                                          // 799
//   userId: String. Account id to which this notification was published.                                              // 800
//   notificationId: String.  ID of the matching event in the Notifications table to dismiss if this                   // 801
//                            notification is activated.                                                               // 802
//   appActivity: Object with fields:                                                                                  // 803
//     user: Optional Object. Not present if this notification wasn't generated by a user. If                          // 804
//           present, it will have one of the following shapes:                                                        // 805
//       { anonymous: true } if this notification was generated by an anonymous user.  Otherwise:                      // 806
//       {                                                                                                             // 807
//         identityId: String  The user's identity ID.                                                                 // 808
//         name: String        The user's display name.                                                                // 809
//         avatarUrl: String   The URL for the user's profile picture.                                                 // 810
//       },                                                                                                            // 811
//     grainId: String,      Which grain this action took place on                                                     // 812
//     path: String,         The path of the notification.                                                             // 813
//     body: Util.LocalizedText,  The main body of the activity event.                                                 // 814
//     actionText: Util.LocalizedText, What action the user took, e.g.                                                 // 815
//                                     { defaultText: "added a comment" }                                              // 816
                                                                                                                       //
var StandaloneDomains = new Mongo.Collection("standaloneDomains", collectionOptions);                                  // 818
// A standalone domain that points to a single share link. These domains act a little different                        // 819
// than a normal shared Sandstorm grain. They completely drop any Sandstorm topbar/sidebar, and at                     // 820
// first glance look completely like a non-Sandstorm hosted webserver. The apps instead act in                         // 821
// concert with Sandstorm through the postMessage API, which allows it to do things like prompt for                    // 822
// login.                                                                                                              // 823
// Fields for each :                                                                                                   // 824
//                                                                                                                     // 825
//   _id: String. The domain name to use.                                                                              // 826
//   token: String. _id of a sharing token (it must be a webkey).                                                      // 827
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 829
  Meteor.publish("credentials", function () {                                                                          // 830
    // Data needed for isSignedUp() and isAdmin() to work.                                                             // 831
                                                                                                                       //
    if (this.userId) {                                                                                                 // 833
      var db = this.connection.sandstormDb;                                                                            // 834
      return [Meteor.users.find({ _id: this.userId }, { fields: { signupKey: 1, isAdmin: 1, expires: 1, storageUsage: 1,
          plan: 1, planBonus: 1, hasCompletedSignup: 1, experiments: 1,                                                // 838
          referredIdentityIds: 1, cachedStorageQuota: 1, suspended: 1 } }), db.collections.plans.find()];              // 839
    } else {                                                                                                           // 842
      return [];                                                                                                       // 843
    }                                                                                                                  // 844
  });                                                                                                                  // 845
}                                                                                                                      // 846
                                                                                                                       //
var countReferrals = function countReferrals(user) {                                                                   // 848
  var referredIdentityIds = user.referredIdentityIds;                                                                  // 849
  return referredIdentityIds && referredIdentityIds.length || 0;                                                       // 850
};                                                                                                                     // 851
                                                                                                                       //
var calculateReferralBonus = function calculateReferralBonus(user) {                                                   // 853
  // This function returns an object of the form:                                                                      // 854
  //                                                                                                                   // 855
  // - {grains: 0, storage: 0}                                                                                         // 856
  //                                                                                                                   // 857
  // which are extra resources this account gets as part of participating in the referral                              // 858
  // program. (Storage is measured in bytes, as usual for plans.)                                                      // 859
                                                                                                                       //
  // TODO(cleanup): Consider moving referral bonus logic into Oasis payments module (since it's                        // 861
  //   payments-specific) and aggregating into `planBonus`.                                                            // 862
                                                                                                                       //
  // Authorization note: Only call this if accountId is the current user!                                              // 864
  var isPaid = user.plan && user.plan !== "free";                                                                      // 865
                                                                                                                       //
  successfulReferralsCount = countReferrals(user);                                                                     // 867
  if (isPaid) {                                                                                                        // 868
    var maxPaidStorageBonus = 30 * 1e9;                                                                                // 869
    return { grains: 0,                                                                                                // 870
      storage: Math.min(successfulReferralsCount * 2 * 1e9, maxPaidStorageBonus) };                                    // 871
  } else {                                                                                                             // 874
    var maxFreeStorageBonus = 2 * 1e9;                                                                                 // 875
    var bonus = {                                                                                                      // 876
      storage: Math.min(successfulReferralsCount * 50 * 1e6, maxFreeStorageBonus)                                      // 877
    };                                                                                                                 // 876
    if (successfulReferralsCount > 0) {                                                                                // 881
      bonus.grains = Infinity;                                                                                         // 882
    } else {                                                                                                           // 883
      bonus.grains = 0;                                                                                                // 884
    }                                                                                                                  // 885
                                                                                                                       //
    return bonus;                                                                                                      // 887
  }                                                                                                                    // 888
};                                                                                                                     // 889
                                                                                                                       //
isAdmin = function isAdmin() {                                                                                         // 891
  // Returns true if the user is the administrator.                                                                    // 892
                                                                                                                       //
  var user = Meteor.user();                                                                                            // 894
  if (user && user.isAdmin) {                                                                                          // 895
    return true;                                                                                                       // 896
  } else {                                                                                                             // 897
    return false;                                                                                                      // 898
  }                                                                                                                    // 899
};                                                                                                                     // 900
                                                                                                                       //
isAdminById = function isAdminById(id) {                                                                               // 902
  // Returns true if the user's id is the administrator.                                                               // 903
                                                                                                                       //
  var user = Meteor.users.findOne({ _id: id }, { fields: { isAdmin: 1 } });                                            // 905
  if (user && user.isAdmin) {                                                                                          // 906
    return true;                                                                                                       // 907
  } else {                                                                                                             // 908
    return false;                                                                                                      // 909
  }                                                                                                                    // 910
};                                                                                                                     // 911
                                                                                                                       //
findAdminUserForToken = function findAdminUserForToken(token) {                                                        // 913
  if (!token.requirements) {                                                                                           // 914
    return;                                                                                                            // 915
  }                                                                                                                    // 916
                                                                                                                       //
  var requirements = token.requirements.filter(function (requirement) {                                                // 918
    return "userIsAdmin" in requirement;                                                                               // 919
  });                                                                                                                  // 920
                                                                                                                       //
  if (requirements.length > 1) {                                                                                       // 922
    return;                                                                                                            // 923
  }                                                                                                                    // 924
                                                                                                                       //
  if (requirements.length === 0) {                                                                                     // 926
    return;                                                                                                            // 927
  }                                                                                                                    // 928
                                                                                                                       //
  return requirements[0].userIsAdmin;                                                                                  // 930
};                                                                                                                     // 931
                                                                                                                       //
var wildcardHost = Meteor.settings["public"].wildcardHost.toLowerCase().split("*");                                    // 933
                                                                                                                       //
if (wildcardHost.length != 2) {                                                                                        // 935
  throw new Error("Wildcard host must contain exactly one asterisk.");                                                 // 936
}                                                                                                                      // 937
                                                                                                                       //
matchWildcardHost = function matchWildcardHost(host) {                                                                 // 939
  // See if the hostname is a member of our wildcard. If so, extract the ID.                                           // 940
                                                                                                                       //
  // We remove everything after the first ":" character so that our                                                    // 942
  // comparison logic ignores port numbers.                                                                            // 943
  var prefix = wildcardHost[0];                                                                                        // 944
  var suffix = wildcardHost[1].split(":")[0];                                                                          // 945
  var hostSansPort = host.split(":")[0];                                                                               // 946
                                                                                                                       //
  if (hostSansPort.lastIndexOf(prefix, 0) >= 0 && hostSansPort.indexOf(suffix, -suffix.length) >= 0 && hostSansPort.length >= prefix.length + suffix.length) {
    var id = hostSansPort.slice(prefix.length, -suffix.length);                                                        // 951
    if (id.match(/^[-a-z0-9]*$/)) {                                                                                    // 952
      return id;                                                                                                       // 953
    }                                                                                                                  // 954
  }                                                                                                                    // 955
                                                                                                                       //
  return null;                                                                                                         // 957
};                                                                                                                     // 958
                                                                                                                       //
makeWildcardHost = function makeWildcardHost(id) {                                                                     // 960
  return wildcardHost[0] + id + wildcardHost[1];                                                                       // 961
};                                                                                                                     // 962
                                                                                                                       //
var isApiHostId = function isApiHostId(hostId) {                                                                       // 964
  if (hostId) {                                                                                                        // 965
    var split = hostId.split("-");                                                                                     // 966
    if (split[0] === "api") return split[1] || "*";                                                                    // 967
  }                                                                                                                    // 968
                                                                                                                       //
  return false;                                                                                                        // 970
};                                                                                                                     // 971
                                                                                                                       //
var isTokenSpecificHostId = function isTokenSpecificHostId(hostId) {                                                   // 973
  return hostId.lastIndexOf("api-", 0) === 0;                                                                          // 974
};                                                                                                                     // 975
                                                                                                                       //
var apiHostIdHashForToken = void 0;                                                                                    // 977
if (Meteor.isServer) {                                                                                                 // 978
  (function () {                                                                                                       // 978
    var Crypto = Npm.require("crypto");                                                                                // 979
    apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                    // 980
      // Given an API token, compute the host ID that must be used when requesting this token.                         // 981
                                                                                                                       //
      // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                      // 983
      // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                     // 984
      // of tokens). This doesn't technically add any security, but helps prove that we don't have                     // 985
      // any bugs which would allow someone who knows only the hostname to access the app API.                         // 986
      return Crypto.createHash("sha256").update("x" + token).digest("hex").slice(0, 32);                               // 987
    };                                                                                                                 // 988
  })();                                                                                                                // 978
} else {                                                                                                               // 989
  apiHostIdHashForToken = function apiHostIdHashForToken(token) {                                                      // 990
    // Given an API token, compute the host ID that must be used when requesting this token.                           // 991
                                                                                                                       //
    // We add a leading 'x' to the hash so that knowing the hostname alone is not sufficient to                        // 993
    // find the corresponding API token in the ApiTokens table (whose _id values are also hashes                       // 994
    // of tokens). This doesn't technically add any security, but helps prove that we don't have                       // 995
    // any bugs which would allow someone who knows only the hostname to access the app API.                           // 996
    return SHA256("x" + token).slice(0, 32);                                                                           // 997
  };                                                                                                                   // 998
}                                                                                                                      // 999
                                                                                                                       //
var apiHostIdForToken = function apiHostIdForToken(token) {                                                            // 1001
  return "api-" + apiHostIdHashForToken(token);                                                                        // 1002
};                                                                                                                     // 1003
                                                                                                                       //
var makeApiHost = function makeApiHost(token) {                                                                        // 1005
  return makeWildcardHost(apiHostIdForToken(token));                                                                   // 1006
};                                                                                                                     // 1007
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1009
  (function () {                                                                                                       // 1009
    var Url = Npm.require("url");                                                                                      // 1010
    getWildcardOrigin = function getWildcardOrigin() {                                                                 // 1011
      // The wildcard URL can be something like "foo-*-bar.example.com", but sometimes when we're                      // 1012
      // trying to specify a pattern matching hostnames (say, a Content-Security-Policy directive),                    // 1013
      // an astrisk is only allowed as the first character and must be followed by a period. So we need                // 1014
      // "*.example.com" instead -- which matches more than we actually want, but is the best we can                   // 1015
      // really do. We also add the protocol to the front (again, that's what CSP wants).                              // 1016
                                                                                                                       //
      // TODO(cleanup): `protocol` is computed in other files, like proxy.js. Put it somewhere common.                 // 1018
      var protocol = Url.parse(process.env.ROOT_URL).protocol;                                                         // 1019
                                                                                                                       //
      var dotPos = wildcardHost[1].indexOf(".");                                                                       // 1021
      if (dotPos < 0) {                                                                                                // 1022
        return protocol + "//*";                                                                                       // 1023
      } else {                                                                                                         // 1024
        return protocol + "//*" + wildcardHost[1].slice(dotPos);                                                       // 1025
      }                                                                                                                // 1026
    };                                                                                                                 // 1027
  })();                                                                                                                // 1009
}                                                                                                                      // 1028
                                                                                                                       //
SandstormDb = function SandstormDb(quotaManager) {                                                                     // 1030
  // quotaManager is an object with the following method:                                                              // 1031
  //   updateUserQuota: It is provided two arguments                                                                   // 1032
  //     db: This SandstormDb object                                                                                   // 1033
  //     user: A collections.users account object                                                                      // 1034
  //   and returns a quota object:                                                                                     // 1035
  //     storage: A number (can be Infinity)                                                                           // 1036
  //     compute: A number (can be Infinity)                                                                           // 1037
  //     grains: A number (can be Infinity)                                                                            // 1038
                                                                                                                       //
  this.quotaManager = quotaManager;                                                                                    // 1040
  this.collections = {                                                                                                 // 1041
    // Direct access to underlying collections. DEPRECATED, but better than accessing the top-level                    // 1042
    // collection globals directly.                                                                                    // 1043
    //                                                                                                                 // 1044
    // TODO(cleanup): Over time, we will provide methods covering each supported query and remove                      // 1045
    //   direct access to the collections.                                                                             // 1046
    users: Meteor.users,                                                                                               // 1047
                                                                                                                       //
    packages: Packages,                                                                                                // 1049
    devPackages: DevPackages,                                                                                          // 1050
    userActions: UserActions,                                                                                          // 1051
    grains: Grains,                                                                                                    // 1052
    roleAssignments: RoleAssignments, // Deprecated, only used by the migration that eliminated it.                    // 1053
    contacts: Contacts,                                                                                                // 1054
    sessions: Sessions,                                                                                                // 1055
    signupKeys: SignupKeys,                                                                                            // 1056
    activityStats: ActivityStats,                                                                                      // 1057
    deleteStats: DeleteStats,                                                                                          // 1058
    fileTokens: FileTokens,                                                                                            // 1059
    spkTokens: SpkTokens,                                                                                              // 1060
    apiTokens: ApiTokens,                                                                                              // 1061
    apiHosts: ApiHosts,                                                                                                // 1062
    notifications: Notifications,                                                                                      // 1063
    activitySubscriptions: ActivitySubscriptions,                                                                      // 1064
    statsTokens: StatsTokens,                                                                                          // 1065
    misc: Misc,                                                                                                        // 1066
    settings: Settings,                                                                                                // 1067
    migrations: Migrations,                                                                                            // 1068
    staticAssets: StaticAssets,                                                                                        // 1069
    assetUploadTokens: AssetUploadTokens,                                                                              // 1070
    plans: Plans,                                                                                                      // 1071
    appIndex: AppIndex,                                                                                                // 1072
    keybaseProfiles: KeybaseProfiles,                                                                                  // 1073
    setupSession: SetupSession,                                                                                        // 1074
    desktopNotifications: DesktopNotifications,                                                                        // 1075
    standaloneDomains: StandaloneDomains                                                                               // 1076
  };                                                                                                                   // 1041
};                                                                                                                     // 1078
                                                                                                                       //
// TODO(cleanup): These methods should not be defined freestanding and should use collection                           // 1080
//   objects created in SandstormDb's constructor rather than globals.                                                 // 1081
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1083
  isAdmin: isAdmin,                                                                                                    // 1084
  isAdminById: isAdminById,                                                                                            // 1085
  findAdminUserForToken: findAdminUserForToken,                                                                        // 1086
  matchWildcardHost: matchWildcardHost,                                                                                // 1087
  makeWildcardHost: makeWildcardHost,                                                                                  // 1088
  isApiHostId: isApiHostId,                                                                                            // 1089
  isTokenSpecificHostId: isTokenSpecificHostId,                                                                        // 1090
  apiHostIdHashForToken: apiHostIdHashForToken,                                                                        // 1091
  apiHostIdForToken: apiHostIdForToken,                                                                                // 1092
  makeApiHost: makeApiHost,                                                                                            // 1093
  allowDevAccounts: function () {                                                                                      // 1094
    function allowDevAccounts() {                                                                                      // 1083
      var setting = this.collections.settings.findOne({ _id: "devAccounts" });                                         // 1095
      if (setting) {                                                                                                   // 1096
        return setting.value;                                                                                          // 1097
      } else {                                                                                                         // 1098
        return Meteor.settings && Meteor.settings["public"] && Meteor.settings["public"].allowDevAccounts;             // 1099
      }                                                                                                                // 1101
    }                                                                                                                  // 1102
                                                                                                                       //
    return allowDevAccounts;                                                                                           // 1083
  }(),                                                                                                                 // 1083
                                                                                                                       //
                                                                                                                       //
  roleAssignmentPattern: {                                                                                             // 1104
    none: Match.Optional(null),                                                                                        // 1105
    allAccess: Match.Optional(null),                                                                                   // 1106
    roleId: Match.Optional(Match.Integer),                                                                             // 1107
    addPermissions: Match.Optional([Boolean]),                                                                         // 1108
    removePermissions: Match.Optional([Boolean])                                                                       // 1109
  },                                                                                                                   // 1104
                                                                                                                       //
  isDemoUser: function () {                                                                                            // 1112
    function isDemoUser() {                                                                                            // 1083
      // Returns true if this is a demo user.                                                                          // 1113
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 1115
      if (user && user.expires) {                                                                                      // 1116
        return true;                                                                                                   // 1117
      } else {                                                                                                         // 1118
        return false;                                                                                                  // 1119
      }                                                                                                                // 1120
    }                                                                                                                  // 1121
                                                                                                                       //
    return isDemoUser;                                                                                                 // 1083
  }(),                                                                                                                 // 1083
  isSignedUp: function () {                                                                                            // 1123
    function isSignedUp() {                                                                                            // 1083
      var user = Meteor.user();                                                                                        // 1124
      return this.isAccountSignedUp(user);                                                                             // 1125
    }                                                                                                                  // 1126
                                                                                                                       //
    return isSignedUp;                                                                                                 // 1083
  }(),                                                                                                                 // 1083
  isAccountSignedUp: function () {                                                                                     // 1128
    function isAccountSignedUp(user) {                                                                                 // 1083
      // Returns true if the user has presented an invite key.                                                         // 1129
                                                                                                                       //
      if (!user) return false; // not signed in                                                                        // 1131
                                                                                                                       //
      if (!user.loginIdentities) return false; // not an account                                                       // 1133
                                                                                                                       //
      if (user.expires) return false; // demo user.                                                                    // 1135
                                                                                                                       //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                               // 1137
                                                                                                                       //
      if (user.signupKey) return true; // user is invited                                                              // 1139
                                                                                                                       //
      if (this.isUserInOrganization(user)) return true;                                                                // 1141
                                                                                                                       //
      return false;                                                                                                    // 1143
    }                                                                                                                  // 1144
                                                                                                                       //
    return isAccountSignedUp;                                                                                          // 1083
  }(),                                                                                                                 // 1083
  isSignedUpOrDemo: function () {                                                                                      // 1146
    function isSignedUpOrDemo() {                                                                                      // 1083
      var user = Meteor.user();                                                                                        // 1147
      return this.isAccountSignedUpOrDemo(user);                                                                       // 1148
    }                                                                                                                  // 1149
                                                                                                                       //
    return isSignedUpOrDemo;                                                                                           // 1083
  }(),                                                                                                                 // 1083
  isAccountSignedUpOrDemo: function () {                                                                               // 1151
    function isAccountSignedUpOrDemo(user) {                                                                           // 1083
      if (!user) return false; // not signed in                                                                        // 1152
                                                                                                                       //
      if (!user.loginIdentities) return false; // not an account                                                       // 1154
                                                                                                                       //
      if (user.expires) return true; // demo user.                                                                     // 1156
                                                                                                                       //
      if (Meteor.settings["public"].allowUninvited) return true; // all accounts qualify                               // 1158
                                                                                                                       //
      if (user.signupKey) return true; // user is invited                                                              // 1160
                                                                                                                       //
      if (this.isUserInOrganization(user)) return true;                                                                // 1162
                                                                                                                       //
      return false;                                                                                                    // 1164
    }                                                                                                                  // 1165
                                                                                                                       //
    return isAccountSignedUpOrDemo;                                                                                    // 1083
  }(),                                                                                                                 // 1083
  isIdentityInOrganization: function () {                                                                              // 1167
    function isIdentityInOrganization(identity) {                                                                      // 1083
      if (!identity || !identity.services) {                                                                           // 1168
        return false;                                                                                                  // 1169
      }                                                                                                                // 1170
                                                                                                                       //
      var orgMembership = this.getOrganizationMembership();                                                            // 1172
      var googleEnabled = orgMembership && orgMembership.google && orgMembership.google.enabled;                       // 1173
      var googleDomain = orgMembership && orgMembership.google && orgMembership.google.domain;                         // 1174
      var emailEnabled = orgMembership && orgMembership.emailToken && orgMembership.emailToken.enabled;                // 1175
      var emailDomain = orgMembership && orgMembership.emailToken && orgMembership.emailToken.domain;                  // 1176
      var ldapEnabled = orgMembership && orgMembership.ldap && orgMembership.ldap.enabled;                             // 1177
      var samlEnabled = orgMembership && orgMembership.saml && orgMembership.saml.enabled;                             // 1178
      if (emailEnabled && emailDomain && identity.services.email) {                                                    // 1179
        var domainSuffixes = emailDomain.split(/\s*,\s*/);                                                             // 1180
        for (var i = 0; i < domainSuffixes.length; i++) {                                                              // 1181
          var suffix = domainSuffixes[i];                                                                              // 1182
          var domain = identity.services.email.email.toLowerCase().split("@").pop();                                   // 1183
          if (suffix.startsWith("*.")) {                                                                               // 1184
            if (domain.endsWith(suffix.substr(1))) {                                                                   // 1185
              return true;                                                                                             // 1186
            }                                                                                                          // 1187
          } else if (domain === suffix) {                                                                              // 1188
            return true;                                                                                               // 1189
          }                                                                                                            // 1190
        }                                                                                                              // 1191
      } else if (ldapEnabled && identity.services.ldap) {                                                              // 1192
        return true;                                                                                                   // 1193
      } else if (samlEnabled && identity.services.saml) {                                                              // 1194
        return true;                                                                                                   // 1195
      } else if (googleEnabled && googleDomain && identity.services.google && identity.services.google.hd) {           // 1196
        if (identity.services.google.hd.toLowerCase() === googleDomain) {                                              // 1197
          return true;                                                                                                 // 1198
        }                                                                                                              // 1199
      }                                                                                                                // 1200
                                                                                                                       //
      return false;                                                                                                    // 1202
    }                                                                                                                  // 1203
                                                                                                                       //
    return isIdentityInOrganization;                                                                                   // 1083
  }(),                                                                                                                 // 1083
  isUserInOrganization: function () {                                                                                  // 1205
    function isUserInOrganization(user) {                                                                              // 1083
      for (var i = 0; i < user.loginIdentities.length; i++) {                                                          // 1206
        var identity = Meteor.users.findOne({ _id: user.loginIdentities[i].id });                                      // 1207
        if (this.isIdentityInOrganization(identity)) {                                                                 // 1208
          return true;                                                                                                 // 1209
        }                                                                                                              // 1210
      }                                                                                                                // 1211
                                                                                                                       //
      return false;                                                                                                    // 1213
    }                                                                                                                  // 1214
                                                                                                                       //
    return isUserInOrganization;                                                                                       // 1083
  }()                                                                                                                  // 1083
});                                                                                                                    // 1083
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 1217
  (function () {                                                                                                       // 1217
    SandstormDb.prototype.getWildcardOrigin = getWildcardOrigin;                                                       // 1218
                                                                                                                       //
    var Crypto = Npm.require("crypto");                                                                                // 1220
    SandstormDb.prototype.removeApiTokens = function (query) {                                                         // 1221
      var _this2 = this;                                                                                               // 1221
                                                                                                                       //
      // Remove all API tokens matching the query, making sure to clean up ApiHosts as well.                           // 1222
                                                                                                                       //
      this.collections.apiTokens.find(query).forEach(function (token) {                                                // 1224
        // Clean up ApiHosts for webkey tokens.                                                                        // 1225
        if (token.hasApiHost) {                                                                                        // 1226
          var hash2 = Crypto.createHash("sha256").update(token._id).digest("base64");                                  // 1227
          _this2.collections.apiHosts.remove({ hash2: hash2 });                                                        // 1228
        }                                                                                                              // 1229
                                                                                                                       //
        // TODO(soon): Drop remote OAuth tokens for frontendRef.http. Unfortunately the way to do                      // 1231
        //   this is different for every service. :( Also we may need to clarify with the "bearer"                     // 1232
        //   type whether or not the token is "owned" by us...                                                         // 1233
      });                                                                                                              // 1234
                                                                                                                       //
      this.collections.apiTokens.remove(query);                                                                        // 1236
    };                                                                                                                 // 1237
  })();                                                                                                                // 1217
}                                                                                                                      // 1238
                                                                                                                       //
// TODO(someday): clean this up.  Logic for building static asset urls on client and server                            // 1240
// appears all over the codebase.                                                                                      // 1241
var httpProtocol = void 0;                                                                                             // 1242
if (Meteor.isServer) {                                                                                                 // 1243
  var _Url = Npm.require("url");                                                                                       // 1244
  httpProtocol = _Url.parse(process.env.ROOT_URL).protocol;                                                            // 1245
} else {                                                                                                               // 1246
  httpProtocol = window.location.protocol;                                                                             // 1247
}                                                                                                                      // 1248
                                                                                                                       //
// =======================================================================================                             // 1250
// Below this point are newly-written or refactored functions.                                                         // 1251
                                                                                                                       //
_.extend(SandstormDb.prototype, {                                                                                      // 1253
  getUser: function () {                                                                                               // 1254
    function getUser(userId) {                                                                                         // 1253
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1255
      if (userId) {                                                                                                    // 1256
        return Meteor.users.findOne(userId);                                                                           // 1257
      }                                                                                                                // 1258
    }                                                                                                                  // 1259
                                                                                                                       //
    return getUser;                                                                                                    // 1253
  }(),                                                                                                                 // 1253
  getIdentity: function () {                                                                                           // 1261
    function getIdentity(identityId) {                                                                                 // 1253
      check(identityId, String);                                                                                       // 1262
      var identity = Meteor.users.findOne({ _id: identityId });                                                        // 1263
      if (identity) {                                                                                                  // 1264
        SandstormDb.fillInProfileDefaults(identity);                                                                   // 1265
        SandstormDb.fillInIntrinsicName(identity);                                                                     // 1266
        SandstormDb.fillInPictureUrl(identity);                                                                        // 1267
        return identity;                                                                                               // 1268
      }                                                                                                                // 1269
    }                                                                                                                  // 1270
                                                                                                                       //
    return getIdentity;                                                                                                // 1253
  }(),                                                                                                                 // 1253
  userHasIdentity: function () {                                                                                       // 1272
    function userHasIdentity(userId, identityId) {                                                                     // 1253
      check(userId, String);                                                                                           // 1273
      check(identityId, String);                                                                                       // 1274
                                                                                                                       //
      if (userId === identityId) return true;                                                                          // 1276
                                                                                                                       //
      var user = Meteor.users.findOne(userId);                                                                         // 1278
      return SandstormDb.getUserIdentityIds(user).indexOf(identityId) != -1;                                           // 1279
    }                                                                                                                  // 1280
                                                                                                                       //
    return userHasIdentity;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  userGrains: function () {                                                                                            // 1282
    function userGrains(userId, options) {                                                                             // 1253
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1283
      check(options, Match.OneOf(undefined, null, { includeTrashOnly: Match.Optional(Boolean), includeTrash: Match.Optional(Boolean) }));
                                                                                                                       //
      var query = { userId: userId };                                                                                  // 1287
      if (options && options.includeTrashOnly) {                                                                       // 1288
        query.trashed = { $exists: true };                                                                             // 1289
      } else if (options && options.includeTrash) {                                                                    // 1290
        // Keep query as-is.                                                                                           // 1291
      } else {                                                                                                         // 1292
        query.trashed = { $exists: false };                                                                            // 1293
      }                                                                                                                // 1294
                                                                                                                       //
      return this.collections.grains.find(query);                                                                      // 1296
    }                                                                                                                  // 1297
                                                                                                                       //
    return userGrains;                                                                                                 // 1253
  }(),                                                                                                                 // 1253
  currentUserGrains: function () {                                                                                     // 1299
    function currentUserGrains(options) {                                                                              // 1253
      return this.userGrains(Meteor.userId(), options);                                                                // 1300
    }                                                                                                                  // 1301
                                                                                                                       //
    return currentUserGrains;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getGrain: function () {                                                                                              // 1303
    function getGrain(grainId) {                                                                                       // 1253
      check(grainId, String);                                                                                          // 1304
      return this.collections.grains.findOne(grainId);                                                                 // 1305
    }                                                                                                                  // 1306
                                                                                                                       //
    return getGrain;                                                                                                   // 1253
  }(),                                                                                                                 // 1253
  userApiTokens: function () {                                                                                         // 1308
    function userApiTokens(userId, trashed) {                                                                          // 1253
      check(userId, Match.OneOf(String, undefined, null));                                                             // 1309
      check(trashed, Match.OneOf(Boolean, undefined, null));                                                           // 1310
      var identityIds = SandstormDb.getUserIdentityIds(this.getUser(userId));                                          // 1311
      return this.collections.apiTokens.find({                                                                         // 1312
        "owner.user.identityId": { $in: identityIds },                                                                 // 1313
        trashed: { $exists: !!trashed }                                                                                // 1314
      });                                                                                                              // 1312
    }                                                                                                                  // 1316
                                                                                                                       //
    return userApiTokens;                                                                                              // 1253
  }(),                                                                                                                 // 1253
  currentUserApiTokens: function () {                                                                                  // 1318
    function currentUserApiTokens(trashed) {                                                                           // 1253
      return this.userApiTokens(Meteor.userId(), trashed);                                                             // 1319
    }                                                                                                                  // 1320
                                                                                                                       //
    return currentUserApiTokens;                                                                                       // 1253
  }(),                                                                                                                 // 1253
  userActions: function () {                                                                                           // 1322
    function userActions(user) {                                                                                       // 1253
      return this.collections.userActions.find({ userId: user });                                                      // 1323
    }                                                                                                                  // 1324
                                                                                                                       //
    return userActions;                                                                                                // 1253
  }(),                                                                                                                 // 1253
  currentUserActions: function () {                                                                                    // 1326
    function currentUserActions() {                                                                                    // 1253
      return this.userActions(Meteor.userId());                                                                        // 1327
    }                                                                                                                  // 1328
                                                                                                                       //
    return currentUserActions;                                                                                         // 1253
  }(),                                                                                                                 // 1253
  iconSrcForPackage: function () {                                                                                     // 1330
    function iconSrcForPackage(pkg, usage) {                                                                           // 1253
      return Identicon.iconSrcForPackage(pkg, usage, httpProtocol + "//" + this.makeWildcardHost("static"));           // 1331
    }                                                                                                                  // 1332
                                                                                                                       //
    return iconSrcForPackage;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getDenormalizedGrainInfo: function () {                                                                              // 1334
    function getDenormalizedGrainInfo(grainId) {                                                                       // 1253
      var grain = this.getGrain(grainId);                                                                              // 1335
      var pkg = this.collections.packages.findOne(grain.packageId);                                                    // 1336
                                                                                                                       //
      if (!pkg) {                                                                                                      // 1338
        pkg = this.collections.devPackages.findOne(grain.packageId);                                                   // 1339
      }                                                                                                                // 1340
                                                                                                                       //
      var appTitle = pkg && pkg.manifest && pkg.manifest.appTitle || { defaultText: "" };                              // 1342
      var grainInfo = { appTitle: appTitle };                                                                          // 1343
                                                                                                                       //
      if (pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.icons) {                               // 1345
        var icons = pkg.manifest.metadata.icons;                                                                       // 1346
        var icon = icons.grain || icons.appGrid;                                                                       // 1347
        if (icon) {                                                                                                    // 1348
          grainInfo.icon = icon;                                                                                       // 1349
        }                                                                                                              // 1350
      }                                                                                                                // 1351
                                                                                                                       //
      // Only provide an app ID if we have no icon asset to provide and need to offer an identicon.                    // 1353
      if (!grainInfo.icon && pkg) {                                                                                    // 1354
        grainInfo.appId = pkg.appId;                                                                                   // 1355
      }                                                                                                                // 1356
                                                                                                                       //
      return grainInfo;                                                                                                // 1358
    }                                                                                                                  // 1359
                                                                                                                       //
    return getDenormalizedGrainInfo;                                                                                   // 1253
  }(),                                                                                                                 // 1253
  getPlan: function () {                                                                                               // 1361
    function getPlan(id, user) {                                                                                       // 1253
      check(id, String);                                                                                               // 1362
                                                                                                                       //
      // `user`, if provided, is the user observing the plan. This matters only for checking if the                    // 1364
      // user is in an experiment.                                                                                     // 1365
                                                                                                                       //
      var plan = this.collections.plans.findOne(id);                                                                   // 1367
      if (!plan) {                                                                                                     // 1368
        throw new Error("no such plan: " + id);                                                                        // 1369
      }                                                                                                                // 1370
                                                                                                                       //
      if (plan._id === "free") {                                                                                       // 1372
        user = user || Meteor.user();                                                                                  // 1373
        if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                         // 1374
          plan.grains = user.experiments.freeGrainLimit;                                                               // 1376
        }                                                                                                              // 1377
      }                                                                                                                // 1378
                                                                                                                       //
      return plan;                                                                                                     // 1380
    }                                                                                                                  // 1381
                                                                                                                       //
    return getPlan;                                                                                                    // 1253
  }(),                                                                                                                 // 1253
  listPlans: function () {                                                                                             // 1383
    function listPlans(user) {                                                                                         // 1253
      user = user || Meteor.user();                                                                                    // 1384
      if (user && user.experiments && typeof user.experiments.freeGrainLimit === "number") {                           // 1385
        return this.collections.plans.find({}, { sort: { price: 1 } }).map(function (plan) {                           // 1387
          if (plan._id === "free") {                                                                                   // 1389
            plan.grains = user.experiments.freeGrainLimit;                                                             // 1390
          }                                                                                                            // 1391
                                                                                                                       //
          return plan;                                                                                                 // 1393
        });                                                                                                            // 1394
      } else {                                                                                                         // 1395
        return this.collections.plans.find({}, { sort: { price: 1 } }).fetch();                                        // 1396
      }                                                                                                                // 1397
    }                                                                                                                  // 1398
                                                                                                                       //
    return listPlans;                                                                                                  // 1253
  }(),                                                                                                                 // 1253
  getMyPlan: function () {                                                                                             // 1400
    function getMyPlan() {                                                                                             // 1253
      var user = Meteor.user();                                                                                        // 1401
      return user && this.collections.plans.findOne(user.plan || "free");                                              // 1402
    }                                                                                                                  // 1403
                                                                                                                       //
    return getMyPlan;                                                                                                  // 1253
  }(),                                                                                                                 // 1253
  getMyReferralBonus: function () {                                                                                    // 1405
    function getMyReferralBonus(user) {                                                                                // 1253
      // This function is called from the server and from the client, similar to getMyPlan().                          // 1406
      //                                                                                                               // 1407
      // The parameter may be omitted in which case the current user is assumed.                                       // 1408
                                                                                                                       //
      return calculateReferralBonus(user || Meteor.user());                                                            // 1410
    }                                                                                                                  // 1411
                                                                                                                       //
    return getMyReferralBonus;                                                                                         // 1253
  }(),                                                                                                                 // 1253
  getMyUsage: function () {                                                                                            // 1413
    function getMyUsage(user) {                                                                                        // 1253
      user = user || Meteor.user();                                                                                    // 1414
      if (user && (Meteor.isServer || user.pseudoUsage)) {                                                             // 1415
        if (Meteor.isClient) {                                                                                         // 1416
          // Filled by pseudo-subscription to "getMyUsage". WARNING: The subscription is currently                     // 1417
          // not reactive.                                                                                             // 1418
          return user.pseudoUsage;                                                                                     // 1419
        } else {                                                                                                       // 1420
          return {                                                                                                     // 1421
            grains: this.collections.grains.find({ userId: user._id }).count(),                                        // 1422
            storage: user.storageUsage || 0,                                                                           // 1423
            compute: 0 };                                                                                              // 1424
        }                                                                                                              // 1426
      } else {                                                                                                         // 1427
        return { grains: 0, storage: 0, compute: 0 };                                                                  // 1428
      }                                                                                                                // 1429
    }                                                                                                                  // 1430
                                                                                                                       //
    return getMyUsage;                                                                                                 // 1253
  }(),                                                                                                                 // 1253
  isUninvitedFreeUser: function () {                                                                                   // 1432
    function isUninvitedFreeUser() {                                                                                   // 1253
      if (!Meteor.settings["public"].allowUninvited) return false;                                                     // 1433
                                                                                                                       //
      var user = Meteor.user();                                                                                        // 1435
      return user && !user.expires && (!user.plan || user.plan === "free");                                            // 1436
    }                                                                                                                  // 1437
                                                                                                                       //
    return isUninvitedFreeUser;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  getSetting: function () {                                                                                            // 1439
    function getSetting(name) {                                                                                        // 1253
      var setting = this.collections.settings.findOne(name);                                                           // 1440
      return setting && setting.value;                                                                                 // 1441
    }                                                                                                                  // 1442
                                                                                                                       //
    return getSetting;                                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getSettingWithFallback: function () {                                                                                // 1444
    function getSettingWithFallback(name, fallbackValue) {                                                             // 1253
      var value = this.getSetting(name);                                                                               // 1445
      if (value === undefined) {                                                                                       // 1446
        return fallbackValue;                                                                                          // 1447
      }                                                                                                                // 1448
                                                                                                                       //
      return value;                                                                                                    // 1450
    }                                                                                                                  // 1451
                                                                                                                       //
    return getSettingWithFallback;                                                                                     // 1253
  }(),                                                                                                                 // 1253
  addUserActions: function () {                                                                                        // 1453
    function addUserActions(userId, packageId, simulation) {                                                           // 1253
      check(userId, String);                                                                                           // 1454
      check(packageId, String);                                                                                        // 1455
                                                                                                                       //
      var pack = this.collections.packages.findOne({ _id: packageId });                                                // 1457
      if (pack) {                                                                                                      // 1458
        // Remove old versions.                                                                                        // 1459
        var numRemoved = this.collections.userActions.remove({ userId: userId, appId: pack.appId });                   // 1460
                                                                                                                       //
        // Install new.                                                                                                // 1462
        var actions = pack.manifest.actions;                                                                           // 1463
        for (var i in meteorBabelHelpers.sanitizeForInObject(actions)) {                                               // 1464
          var action = actions[i];                                                                                     // 1465
          if ("none" in action.input) {                                                                                // 1466
            var userAction = {                                                                                         // 1467
              userId: userId,                                                                                          // 1468
              packageId: pack._id,                                                                                     // 1469
              appId: pack.appId,                                                                                       // 1470
              appTitle: pack.manifest.appTitle,                                                                        // 1471
              appMarketingVersion: pack.manifest.appMarketingVersion,                                                  // 1472
              appVersion: pack.manifest.appVersion,                                                                    // 1473
              title: action.title,                                                                                     // 1474
              nounPhrase: action.nounPhrase,                                                                           // 1475
              command: action.command                                                                                  // 1476
            };                                                                                                         // 1467
            this.collections.userActions.insert(userAction);                                                           // 1478
          } else {                                                                                                     // 1479
            // TODO(someday):  Implement actions with capability inputs.                                               // 1480
          }                                                                                                            // 1481
        }                                                                                                              // 1482
                                                                                                                       //
        if (numRemoved > 0 && !simulation) {                                                                           // 1484
          this.deleteUnusedPackages(pack.appId);                                                                       // 1485
        }                                                                                                              // 1486
      }                                                                                                                // 1487
    }                                                                                                                  // 1488
                                                                                                                       //
    return addUserActions;                                                                                             // 1253
  }(),                                                                                                                 // 1253
  sendAdminNotification: function () {                                                                                 // 1490
    function sendAdminNotification(type, action) {                                                                     // 1253
      Meteor.users.find({ isAdmin: true }, { fields: { _id: 1 } }).forEach(function (user) {                           // 1491
        Notifications.insert({                                                                                         // 1492
          admin: { action: action, type: type },                                                                       // 1493
          userId: user._id,                                                                                            // 1494
          timestamp: new Date(),                                                                                       // 1495
          isUnread: true                                                                                               // 1496
        });                                                                                                            // 1492
      });                                                                                                              // 1498
    }                                                                                                                  // 1499
                                                                                                                       //
    return sendAdminNotification;                                                                                      // 1253
  }(),                                                                                                                 // 1253
  getKeybaseProfile: function () {                                                                                     // 1501
    function getKeybaseProfile(keyFingerprint) {                                                                       // 1253
      return this.collections.keybaseProfiles.findOne(keyFingerprint) || {};                                           // 1502
    }                                                                                                                  // 1503
                                                                                                                       //
    return getKeybaseProfile;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getServerTitle: function () {                                                                                        // 1505
    function getServerTitle() {                                                                                        // 1253
      var setting = this.collections.settings.findOne({ _id: "serverTitle" });                                         // 1506
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1507
    }                                                                                                                  // 1508
                                                                                                                       //
    return getServerTitle;                                                                                             // 1253
  }(),                                                                                                                 // 1253
  getSmtpConfig: function () {                                                                                         // 1510
    function getSmtpConfig() {                                                                                         // 1253
      var setting = this.collections.settings.findOne({ _id: "smtpConfig" });                                          // 1511
      return setting ? setting.value : undefined; // undefined if subscription is not ready.                           // 1512
    }                                                                                                                  // 1513
                                                                                                                       //
    return getSmtpConfig;                                                                                              // 1253
  }(),                                                                                                                 // 1253
  getReturnAddress: function () {                                                                                      // 1515
    function getReturnAddress() {                                                                                      // 1253
      var config = this.getSmtpConfig();                                                                               // 1516
      return config && config.returnAddress || ""; // empty if subscription is not ready.                              // 1517
    }                                                                                                                  // 1518
                                                                                                                       //
    return getReturnAddress;                                                                                           // 1253
  }(),                                                                                                                 // 1253
  getReturnAddressWithDisplayName: function () {                                                                       // 1520
    function getReturnAddressWithDisplayName(identityId) {                                                             // 1253
      check(identityId, String);                                                                                       // 1521
      var identity = this.getIdentity(identityId);                                                                     // 1522
      var displayName = identity.profile.name + " (via " + this.getServerTitle() + ")";                                // 1523
                                                                                                                       //
      // First remove any instances of characters that cause trouble for SimpleSmtp. Ideally,                          // 1525
      // we could escape such characters with a backslash, but that does not seem to help here.                        // 1526
      // TODO(cleanup): Unclear whether this sanitization is still necessary now that we return a                      // 1527
      //   structured object and have moved to nodemailer. I'm not touching it for now.                                // 1528
      var sanitized = displayName.replace(/"|<|>|\\|\r/g, "");                                                         // 1529
                                                                                                                       //
      return { name: sanitized, address: this.getReturnAddress() };                                                    // 1531
    }                                                                                                                  // 1532
                                                                                                                       //
    return getReturnAddressWithDisplayName;                                                                            // 1253
  }(),                                                                                                                 // 1253
  getPrimaryEmail: function () {                                                                                       // 1534
    function getPrimaryEmail(accountId, identityId) {                                                                  // 1253
      check(accountId, String);                                                                                        // 1535
      check(identityId, String);                                                                                       // 1536
                                                                                                                       //
      var identity = this.getIdentity(identityId);                                                                     // 1538
      var senderEmails = SandstormDb.getVerifiedEmails(identity);                                                      // 1539
      var senderPrimaryEmail = _.findWhere(senderEmails, { primary: true });                                           // 1540
      var accountPrimaryEmailAddress = this.getUser(accountId).primaryEmail;                                           // 1541
      if (_.findWhere(senderEmails, { email: accountPrimaryEmailAddress })) {                                          // 1542
        return accountPrimaryEmailAddress;                                                                             // 1543
      } else if (senderPrimaryEmail) {                                                                                 // 1544
        return senderPrimaryEmail.email;                                                                               // 1545
      } else {                                                                                                         // 1546
        return null;                                                                                                   // 1547
      }                                                                                                                // 1548
    }                                                                                                                  // 1549
                                                                                                                       //
    return getPrimaryEmail;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  incrementDailySentMailCount: function () {                                                                           // 1551
    function incrementDailySentMailCount(accountId) {                                                                  // 1253
      check(accountId, String);                                                                                        // 1552
                                                                                                                       //
      var DAILY_LIMIT = 50;                                                                                            // 1554
      var result = Meteor.users.findAndModify({                                                                        // 1555
        query: { _id: accountId },                                                                                     // 1556
        update: {                                                                                                      // 1557
          $inc: {                                                                                                      // 1558
            dailySentMailCount: 1                                                                                      // 1559
          }                                                                                                            // 1558
        },                                                                                                             // 1557
        fields: { dailySentMailCount: 1 }                                                                              // 1562
      });                                                                                                              // 1555
                                                                                                                       //
      if (!result.ok) {                                                                                                // 1565
        throw new Error("Couldn't update daily sent mail count.");                                                     // 1566
      }                                                                                                                // 1567
                                                                                                                       //
      var user = result.value;                                                                                         // 1569
      if (user.dailySentMailCount >= DAILY_LIMIT) {                                                                    // 1570
        throw new Error("Sorry, you've reached your e-mail sending limit for today. Currently, Sandstorm " + "limits each user to " + DAILY_LIMIT + " e-mails per day for spam control reasons. " + "Please feel free to contact us if this is a problem.");
      }                                                                                                                // 1575
    }                                                                                                                  // 1576
                                                                                                                       //
    return incrementDailySentMailCount;                                                                                // 1253
  }(),                                                                                                                 // 1253
  getLdapUrl: function () {                                                                                            // 1578
    function getLdapUrl() {                                                                                            // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapUrl" });                                             // 1579
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1580
    }                                                                                                                  // 1581
                                                                                                                       //
    return getLdapUrl;                                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getLdapBase: function () {                                                                                           // 1583
    function getLdapBase() {                                                                                           // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapBase" });                                            // 1584
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1585
    }                                                                                                                  // 1586
                                                                                                                       //
    return getLdapBase;                                                                                                // 1253
  }(),                                                                                                                 // 1253
  getLdapDnPattern: function () {                                                                                      // 1588
    function getLdapDnPattern() {                                                                                      // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapDnPattern" });                                       // 1589
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1590
    }                                                                                                                  // 1591
                                                                                                                       //
    return getLdapDnPattern;                                                                                           // 1253
  }(),                                                                                                                 // 1253
  getLdapSearchUsername: function () {                                                                                 // 1593
    function getLdapSearchUsername() {                                                                                 // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapSearchUsername" });                                  // 1594
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1595
    }                                                                                                                  // 1596
                                                                                                                       //
    return getLdapSearchUsername;                                                                                      // 1253
  }(),                                                                                                                 // 1253
  getLdapNameField: function () {                                                                                      // 1598
    function getLdapNameField() {                                                                                      // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapNameField" });                                       // 1599
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1600
    }                                                                                                                  // 1601
                                                                                                                       //
    return getLdapNameField;                                                                                           // 1253
  }(),                                                                                                                 // 1253
  getLdapEmailField: function () {                                                                                     // 1603
    function getLdapEmailField() {                                                                                     // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapEmailField" });                                      // 1604
      return setting ? setting.value : "mail";                                                                         // 1605
      // default to "mail". This setting was added later, and so could potentially be unset.                           // 1606
    }                                                                                                                  // 1607
                                                                                                                       //
    return getLdapEmailField;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getLdapExplicitDnSelected: function () {                                                                             // 1609
    function getLdapExplicitDnSelected() {                                                                             // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapExplicitDnSelected" });                              // 1610
      return setting && setting.value;                                                                                 // 1611
    }                                                                                                                  // 1612
                                                                                                                       //
    return getLdapExplicitDnSelected;                                                                                  // 1253
  }(),                                                                                                                 // 1253
  getLdapFilter: function () {                                                                                         // 1614
    function getLdapFilter() {                                                                                         // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapFilter" });                                          // 1615
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1616
    }                                                                                                                  // 1617
                                                                                                                       //
    return getLdapFilter;                                                                                              // 1253
  }(),                                                                                                                 // 1253
  getLdapSearchBindDn: function () {                                                                                   // 1619
    function getLdapSearchBindDn() {                                                                                   // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapSearchBindDn" });                                    // 1620
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1621
    }                                                                                                                  // 1622
                                                                                                                       //
    return getLdapSearchBindDn;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  getLdapSearchBindPassword: function () {                                                                             // 1624
    function getLdapSearchBindPassword() {                                                                             // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapSearchBindPassword" });                              // 1625
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1626
    }                                                                                                                  // 1627
                                                                                                                       //
    return getLdapSearchBindPassword;                                                                                  // 1253
  }(),                                                                                                                 // 1253
  getLdapCaCert: function () {                                                                                         // 1629
    function getLdapCaCert() {                                                                                         // 1253
      var setting = this.collections.settings.findOne({ _id: "ldapCaCert" });                                          // 1630
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1631
    }                                                                                                                  // 1632
                                                                                                                       //
    return getLdapCaCert;                                                                                              // 1253
  }(),                                                                                                                 // 1253
  getOrganizationMembership: function () {                                                                             // 1634
    function getOrganizationMembership() {                                                                             // 1253
      var setting = this.collections.settings.findOne({ _id: "organizationMembership" });                              // 1635
      return setting && setting.value;                                                                                 // 1636
    }                                                                                                                  // 1637
                                                                                                                       //
    return getOrganizationMembership;                                                                                  // 1253
  }(),                                                                                                                 // 1253
  getOrganizationEmailEnabled: function () {                                                                           // 1639
    function getOrganizationEmailEnabled() {                                                                           // 1253
      var membership = this.getOrganizationMembership();                                                               // 1640
      return membership && membership.emailToken && membership.emailToken.enabled;                                     // 1641
    }                                                                                                                  // 1642
                                                                                                                       //
    return getOrganizationEmailEnabled;                                                                                // 1253
  }(),                                                                                                                 // 1253
  getOrganizationEmailDomain: function () {                                                                            // 1644
    function getOrganizationEmailDomain() {                                                                            // 1253
      var membership = this.getOrganizationMembership();                                                               // 1645
      return membership && membership.emailToken && membership.emailToken.domain;                                      // 1646
    }                                                                                                                  // 1647
                                                                                                                       //
    return getOrganizationEmailDomain;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getOrganizationGoogleEnabled: function () {                                                                          // 1649
    function getOrganizationGoogleEnabled() {                                                                          // 1253
      var membership = this.getOrganizationMembership();                                                               // 1650
      return membership && membership.google && membership.google.enabled;                                             // 1651
    }                                                                                                                  // 1652
                                                                                                                       //
    return getOrganizationGoogleEnabled;                                                                               // 1253
  }(),                                                                                                                 // 1253
  getOrganizationGoogleDomain: function () {                                                                           // 1654
    function getOrganizationGoogleDomain() {                                                                           // 1253
      var membership = this.getOrganizationMembership();                                                               // 1655
      return membership && membership.google && membership.google.domain;                                              // 1656
    }                                                                                                                  // 1657
                                                                                                                       //
    return getOrganizationGoogleDomain;                                                                                // 1253
  }(),                                                                                                                 // 1253
  getOrganizationLdapEnabled: function () {                                                                            // 1659
    function getOrganizationLdapEnabled() {                                                                            // 1253
      var membership = this.getOrganizationMembership();                                                               // 1660
      return membership && membership.ldap && membership.ldap.enabled;                                                 // 1661
    }                                                                                                                  // 1662
                                                                                                                       //
    return getOrganizationLdapEnabled;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getOrganizationSamlEnabled: function () {                                                                            // 1664
    function getOrganizationSamlEnabled() {                                                                            // 1253
      var membership = this.getOrganizationMembership();                                                               // 1665
      return membership && membership.saml && membership.saml.enabled;                                                 // 1666
    }                                                                                                                  // 1667
                                                                                                                       //
    return getOrganizationSamlEnabled;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getOrganizationDisallowGuests: function () {                                                                         // 1669
    function getOrganizationDisallowGuests() {                                                                         // 1253
      return this.getOrganizationDisallowGuestsRaw();                                                                  // 1670
    }                                                                                                                  // 1671
                                                                                                                       //
    return getOrganizationDisallowGuests;                                                                              // 1253
  }(),                                                                                                                 // 1253
  getOrganizationDisallowGuestsRaw: function () {                                                                      // 1673
    function getOrganizationDisallowGuestsRaw() {                                                                      // 1253
      var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                // 1674
      return setting && setting.value && setting.value.disallowGuests;                                                 // 1675
    }                                                                                                                  // 1676
                                                                                                                       //
    return getOrganizationDisallowGuestsRaw;                                                                           // 1253
  }(),                                                                                                                 // 1253
  getOrganizationShareContacts: function () {                                                                          // 1678
    function getOrganizationShareContacts() {                                                                          // 1253
      return this.getOrganizationShareContactsRaw();                                                                   // 1679
    }                                                                                                                  // 1680
                                                                                                                       //
    return getOrganizationShareContacts;                                                                               // 1253
  }(),                                                                                                                 // 1253
  getOrganizationShareContactsRaw: function () {                                                                       // 1682
    function getOrganizationShareContactsRaw() {                                                                       // 1253
      var setting = this.collections.settings.findOne({ _id: "organizationSettings" });                                // 1683
      if (!setting || !setting.value || setting.value.shareContacts === undefined) {                                   // 1684
        // default to true if undefined                                                                                // 1685
        return true;                                                                                                   // 1686
      } else {                                                                                                         // 1687
        return setting.value.shareContacts;                                                                            // 1688
      }                                                                                                                // 1689
    }                                                                                                                  // 1690
                                                                                                                       //
    return getOrganizationShareContactsRaw;                                                                            // 1253
  }(),                                                                                                                 // 1253
  getSamlEntryPoint: function () {                                                                                     // 1692
    function getSamlEntryPoint() {                                                                                     // 1253
      var setting = this.collections.settings.findOne({ _id: "samlEntryPoint" });                                      // 1693
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1694
    }                                                                                                                  // 1695
                                                                                                                       //
    return getSamlEntryPoint;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getSamlLogout: function () {                                                                                         // 1697
    function getSamlLogout() {                                                                                         // 1253
      var setting = this.collections.settings.findOne({ _id: "samlLogout" });                                          // 1698
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1699
    }                                                                                                                  // 1700
                                                                                                                       //
    return getSamlLogout;                                                                                              // 1253
  }(),                                                                                                                 // 1253
  getSamlPublicCert: function () {                                                                                     // 1702
    function getSamlPublicCert() {                                                                                     // 1253
      var setting = this.collections.settings.findOne({ _id: "samlPublicCert" });                                      // 1703
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1704
    }                                                                                                                  // 1705
                                                                                                                       //
    return getSamlPublicCert;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  getSamlEntityId: function () {                                                                                       // 1707
    function getSamlEntityId() {                                                                                       // 1253
      var setting = this.collections.settings.findOne({ _id: "samlEntityId" });                                        // 1708
      return setting ? setting.value : ""; // empty if subscription is not ready.                                      // 1709
    }                                                                                                                  // 1710
                                                                                                                       //
    return getSamlEntityId;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  userHasSamlLoginIdentity: function () {                                                                              // 1712
    function userHasSamlLoginIdentity() {                                                                              // 1253
      var user = Meteor.user();                                                                                        // 1713
      if (!user.loginIdentities) {                                                                                     // 1714
        return false;                                                                                                  // 1715
      }                                                                                                                // 1716
                                                                                                                       //
      var hasSaml = false;                                                                                             // 1718
      user.loginIdentities.forEach(function (identity) {                                                               // 1719
        if (Meteor.users.findOne({ _id: identity.id }).services.saml) {                                                // 1720
          hasSaml = true;                                                                                              // 1721
        }                                                                                                              // 1722
      });                                                                                                              // 1723
                                                                                                                       //
      return hasSaml;                                                                                                  // 1725
    }                                                                                                                  // 1726
                                                                                                                       //
    return userHasSamlLoginIdentity;                                                                                   // 1253
  }(),                                                                                                                 // 1253
  getActivitySubscriptions: function () {                                                                              // 1728
    function getActivitySubscriptions(grainId, threadPath) {                                                           // 1253
      return this.collections.activitySubscriptions.find({                                                             // 1729
        grainId: grainId,                                                                                              // 1730
        threadPath: threadPath || { $exists: false }                                                                   // 1731
      }, {                                                                                                             // 1729
        fields: { identityId: 1, mute: 1, _id: 0 }                                                                     // 1733
      }).fetch();                                                                                                      // 1732
    }                                                                                                                  // 1735
                                                                                                                       //
    return getActivitySubscriptions;                                                                                   // 1253
  }(),                                                                                                                 // 1253
  subscribeToActivity: function () {                                                                                   // 1737
    function subscribeToActivity(identityId, grainId, threadPath) {                                                    // 1253
      // Subscribe the given identity to activity events with the given grainId and (optional)                         // 1738
      // threadPath -- unless the identity has previously muted this grainId/threadPath, in which                      // 1739
      // case do nothing.                                                                                              // 1740
                                                                                                                       //
      var record = { identityId: identityId, grainId: grainId };                                                       // 1742
      if (threadPath) {                                                                                                // 1743
        record.threadPath = threadPath;                                                                                // 1744
      }                                                                                                                // 1745
                                                                                                                       //
      // The $set here is redundant since an upsert automatically initializes a new record to contain                  // 1747
      // the fields from the query, but if we try to do { $set: {} } Mongo throws an exception, and                    // 1748
      // if we try to just pass {}, Mongo interprets it as "replace the record with an empty record".                  // 1749
      // What a wonderful query language.                                                                              // 1750
      this.collections.activitySubscriptions.upsert(record, { $set: record });                                         // 1751
    }                                                                                                                  // 1752
                                                                                                                       //
    return subscribeToActivity;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  muteActivity: function () {                                                                                          // 1754
    function muteActivity(identityId, grainId, threadPath) {                                                           // 1253
      // Mute notifications for the given identity originating from the given grainId and                              // 1755
      // (optional) threadPath.                                                                                        // 1756
                                                                                                                       //
      var record = { identityId: identityId, grainId: grainId };                                                       // 1758
      if (threadPath) {                                                                                                // 1759
        record.threadPath = threadPath;                                                                                // 1760
      }                                                                                                                // 1761
                                                                                                                       //
      this.collections.activitySubscriptions.upsert(record, { $set: { mute: true } });                                 // 1763
    }                                                                                                                  // 1764
                                                                                                                       //
    return muteActivity;                                                                                               // 1253
  }(),                                                                                                                 // 1253
  updateAppIndex: function () {                                                                                        // 1766
    function updateAppIndex() {                                                                                        // 1253
      var _this3 = this;                                                                                               // 1766
                                                                                                                       //
      var appUpdatesEnabledSetting = this.collections.settings.findOne({ _id: "appUpdatesEnabled" });                  // 1767
      var appUpdatesEnabled = appUpdatesEnabledSetting && appUpdatesEnabledSetting.value;                              // 1768
      if (!appUpdatesEnabled) {                                                                                        // 1769
        // It's much simpler to check appUpdatesEnabled here rather than reactively deactivate the                     // 1770
        // timer that triggers this call.                                                                              // 1771
        return;                                                                                                        // 1772
      }                                                                                                                // 1773
                                                                                                                       //
      var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                               // 1775
      var appIndex = this.collections.appIndex;                                                                        // 1776
      var data = HTTP.get(appIndexUrl + "/apps/index.json").data;                                                      // 1777
      var preinstalledAppIds = this.getAllPreinstalledAppIds();                                                        // 1778
      // We make sure to get all preinstalled appIds, even ones that are currently                                     // 1779
      // downloading/failed.                                                                                           // 1780
      data.apps.forEach(function (app) {                                                                               // 1781
        app._id = app.appId;                                                                                           // 1782
                                                                                                                       //
        var oldApp = appIndex.findOne({ _id: app.appId });                                                             // 1784
        app.hasSentNotifications = false;                                                                              // 1785
        appIndex.upsert({ _id: app._id }, app);                                                                        // 1786
        var isAppPreinstalled = _.contains(preinstalledAppIds, app.appId);                                             // 1787
        if ((!oldApp || app.versionNumber > oldApp.versionNumber) && (_this3.collections.userActions.findOne({ appId: app.appId }) || isAppPreinstalled)) {
          var pack = _this3.collections.packages.findOne({ _id: app.packageId });                                      // 1791
          var url = appIndexUrl + "/packages/" + app.packageId;                                                        // 1792
          if (pack) {                                                                                                  // 1793
            if (pack.status === "ready") {                                                                             // 1794
              if (pack.appId && pack.appId !== app.appId) {                                                            // 1795
                console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));      // 1796
              } else {                                                                                                 // 1798
                _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                if (isAppPreinstalled) {                                                                               // 1801
                  _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                            // 1802
                }                                                                                                      // 1803
              }                                                                                                        // 1804
            } else {                                                                                                   // 1805
              var result = _this3.collections.packages.findAndModify({                                                 // 1806
                query: { _id: app.packageId },                                                                         // 1807
                update: { $set: { isAutoUpdated: true } }                                                              // 1808
              });                                                                                                      // 1806
                                                                                                                       //
              if (!result.ok) {                                                                                        // 1811
                return;                                                                                                // 1812
              }                                                                                                        // 1813
                                                                                                                       //
              var newPack = result.value;                                                                              // 1815
              if (newPack.status === "ready") {                                                                        // 1816
                // The package was marked as ready before we applied isAutoUpdated=true. We should send                // 1817
                // notifications ourselves to be sure there's no timing issue (sending more than one is                // 1818
                // fine, since it will de-dupe).                                                                       // 1819
                if (pack.appId && pack.appId !== app.appId) {                                                          // 1820
                  console.error("app index returned app ID and package ID that don't match:", JSON.stringify(app));    // 1821
                } else {                                                                                               // 1823
                  _this3.sendAppUpdateNotifications(app.appId, app.packageId, app.name, app.versionNumber, app.version);
                  if (isAppPreinstalled) {                                                                             // 1826
                    _this3.setPreinstallAppAsReady(app.appId, app.packageId);                                          // 1827
                  }                                                                                                    // 1828
                }                                                                                                      // 1829
              } else if (newPack.status === "failed") {                                                                // 1830
                // If the package has failed, retry it                                                                 // 1831
                _this3.startInstall(app.packageId, url, true, true);                                                   // 1832
              }                                                                                                        // 1833
            }                                                                                                          // 1834
          } else {                                                                                                     // 1835
            _this3.startInstall(app.packageId, url, false, true);                                                      // 1836
          }                                                                                                            // 1837
        }                                                                                                              // 1838
      });                                                                                                              // 1839
    }                                                                                                                  // 1840
                                                                                                                       //
    return updateAppIndex;                                                                                             // 1253
  }(),                                                                                                                 // 1253
  isPackagePreinstalled: function () {                                                                                 // 1842
    function isPackagePreinstalled(packageId) {                                                                        // 1253
      return this.collections.settings.find({ _id: "preinstalledApps", "value.packageId": packageId }).count() === 1;  // 1843
    }                                                                                                                  // 1844
                                                                                                                       //
    return isPackagePreinstalled;                                                                                      // 1253
  }(),                                                                                                                 // 1253
  getAppIdForPreinstalledPackage: function () {                                                                        // 1846
    function getAppIdForPreinstalledPackage(packageId) {                                                               // 1253
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.packageId": packageId }, { fields: { "value.$": 1 } });
      // value.$ causes mongo to transform the result and only return the first matching element in                    // 1849
      // the array                                                                                                     // 1850
      return setting && setting.value && setting.value[0] && setting.value[0].appId;                                   // 1851
    }                                                                                                                  // 1852
                                                                                                                       //
    return getAppIdForPreinstalledPackage;                                                                             // 1253
  }(),                                                                                                                 // 1253
  getPackageIdForPreinstalledApp: function () {                                                                        // 1854
    function getPackageIdForPreinstalledApp(appId) {                                                                   // 1253
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps", "value.appId": appId }, { fields: { "value.$": 1 } });
      // value.$ causes mongo to transform the result and only return the first matching element in                    // 1857
      // the array                                                                                                     // 1858
      return setting && setting.value && setting.value[0] && setting.value[0].packageId;                               // 1859
    }                                                                                                                  // 1860
                                                                                                                       //
    return getPackageIdForPreinstalledApp;                                                                             // 1253
  }(),                                                                                                                 // 1253
  getReadyPreinstalledAppIds: function () {                                                                            // 1862
    function getReadyPreinstalledAppIds() {                                                                            // 1253
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1863
      var ret = setting && setting.value || [];                                                                        // 1864
      return _.chain(ret).filter(function (app) {                                                                      // 1865
        return app.status === "ready";                                                                                 // 1866
      }).map(function (app) {                                                                                          // 1866
        return app.appId;                                                                                              // 1867
      }).value();                                                                                                      // 1867
    }                                                                                                                  // 1869
                                                                                                                       //
    return getReadyPreinstalledAppIds;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getAllPreinstalledAppIds: function () {                                                                              // 1871
    function getAllPreinstalledAppIds() {                                                                              // 1253
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1872
      var ret = setting && setting.value || [];                                                                        // 1873
      return _.map(ret, function (app) {                                                                               // 1874
        return app.appId;                                                                                              // 1874
      });                                                                                                              // 1874
    }                                                                                                                  // 1875
                                                                                                                       //
    return getAllPreinstalledAppIds;                                                                                   // 1253
  }(),                                                                                                                 // 1253
  preinstallAppsForUser: function () {                                                                                 // 1877
    function preinstallAppsForUser(userId) {                                                                           // 1253
      var _this4 = this;                                                                                               // 1877
                                                                                                                       //
      var appIds = this.getReadyPreinstalledAppIds();                                                                  // 1878
      appIds.forEach(function (appId) {                                                                                // 1879
        try {                                                                                                          // 1880
          _this4.addUserActions(userId, _this4.getPackageIdForPreinstalledApp(appId));                                 // 1881
        } catch (e) {                                                                                                  // 1882
          console.error("failed to install app for user:", e);                                                         // 1883
        }                                                                                                              // 1884
      });                                                                                                              // 1885
    }                                                                                                                  // 1886
                                                                                                                       //
    return preinstallAppsForUser;                                                                                      // 1253
  }(),                                                                                                                 // 1253
  setPreinstallAppAsDownloading: function () {                                                                         // 1888
    function setPreinstallAppAsDownloading(appId, packageId) {                                                         // 1253
      this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId, "value.packageId": packageId }, { $set: { "value.$.status": "downloading" } });
    }                                                                                                                  // 1892
                                                                                                                       //
    return setPreinstallAppAsDownloading;                                                                              // 1253
  }(),                                                                                                                 // 1253
  setPreinstallAppAsReady: function () {                                                                               // 1894
    function setPreinstallAppAsReady(appId, packageId) {                                                               // 1253
      // This function both sets the appId as ready and updates the packageId for the given appId                      // 1895
      // Setting the packageId is especially useful in installer.js, as it always ensures the                          // 1896
      // latest installed package will be set as ready.                                                                // 1897
      this.collections.settings.update({ _id: "preinstalledApps", "value.appId": appId }, { $set: { "value.$.status": "ready", "value.$.packageId": packageId } });
    }                                                                                                                  // 1901
                                                                                                                       //
    return setPreinstallAppAsReady;                                                                                    // 1253
  }(),                                                                                                                 // 1253
  ensureAppPreinstall: function () {                                                                                   // 1903
    function ensureAppPreinstall(appId, packageId) {                                                                   // 1253
      check(appId, String);                                                                                            // 1904
      var appIndexUrl = this.collections.settings.findOne({ _id: "appIndexUrl" }).value;                               // 1905
      var pack = this.collections.packages.findOne({ _id: packageId });                                                // 1906
      var url = appIndexUrl + "/packages/" + packageId;                                                                // 1907
      if (pack && pack.status === "ready") {                                                                           // 1908
        this.setPreinstallAppAsReady(appId, packageId);                                                                // 1909
      } else if (pack && pack.status === "failed") {                                                                   // 1910
        this.setPreinstallAppAsDownloading(appId, packageId);                                                          // 1911
        this.startInstall(packageId, url, true, false);                                                                // 1912
      } else {                                                                                                         // 1913
        this.setPreinstallAppAsDownloading(appId, packageId);                                                          // 1914
        this.startInstall(packageId, url, false, false);                                                               // 1915
      }                                                                                                                // 1916
    }                                                                                                                  // 1917
                                                                                                                       //
    return ensureAppPreinstall;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  setPreinstalledApps: function () {                                                                                   // 1919
    function setPreinstalledApps(appAndPackageIds) {                                                                   // 1253
      var _this5 = this;                                                                                               // 1919
                                                                                                                       //
      // appAndPackageIds: A List[Object] where each element has fields:                                               // 1920
      //     appId: The Packages.appId of the app to install                                                           // 1921
      //     packageId: The Packages._id of the app to install                                                         // 1922
      check(appAndPackageIds, [{ appId: String, packageId: String }]);                                                 // 1923
                                                                                                                       //
      // Start by clearing out the setting. We'll push appIds one by one to it                                         // 1925
      this.collections.settings.upsert({ _id: "preinstalledApps" }, { $set: {                                          // 1926
          value: appAndPackageIds.map(function (data) {                                                                // 1927
            return {                                                                                                   // 1928
              appId: data.appId,                                                                                       // 1929
              status: "notReady",                                                                                      // 1930
              packageId: data.packageId                                                                                // 1931
            };                                                                                                         // 1928
          })                                                                                                           // 1933
        } });                                                                                                          // 1926
      appAndPackageIds.forEach(function (data) {                                                                       // 1935
        _this5.ensureAppPreinstall(data.appId, data.packageId);                                                        // 1936
      });                                                                                                              // 1937
    }                                                                                                                  // 1938
                                                                                                                       //
    return setPreinstalledApps;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  getProductivitySuiteAppIds: function () {                                                                            // 1940
    function getProductivitySuiteAppIds() {                                                                            // 1253
      return ["8aspz4sfjnp8u89000mh2v1xrdyx97ytn8hq71mdzv4p4d8n0n3h", // Davros                                        // 1941
      "h37dm17aa89yrd8zuqpdn36p6zntumtv08fjpu8a8zrte7q1cn60", // Etherpad                                              // 1943
      "vfnwptfn02ty21w715snyyczw0nqxkv3jvawcah10c6z7hj1hnu0", // Rocket.Chat                                           // 1944
      "m86q05rdvj14yvn78ghaxynqz7u2svw6rnttptxx49g1785cdv1h"];                                                         // 1945
    }                                                                                                                  // 1947
                                                                                                                       //
    return getProductivitySuiteAppIds;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  getSystemSuiteAppIds: function () {                                                                                  // 1949
    function getSystemSuiteAppIds() {                                                                                  // 1253
      return ["s3u2xgmqwznz2n3apf30sm3gw1d85y029enw5pymx734cnk5n78h"];                                                 // 1950
    }                                                                                                                  // 1953
                                                                                                                       //
    return getSystemSuiteAppIds;                                                                                       // 1253
  }(),                                                                                                                 // 1253
  isPreinstalledAppsReady: function () {                                                                               // 1955
    function isPreinstalledAppsReady() {                                                                               // 1253
      var setting = this.collections.settings.findOne({ _id: "preinstalledApps" });                                    // 1956
      if (!setting || !setting.value) {                                                                                // 1957
        return true;                                                                                                   // 1958
      }                                                                                                                // 1959
                                                                                                                       //
      var packageIds = _.pluck(setting.value, "packageId");                                                            // 1961
      var readyApps = this.collections.packages.find({                                                                 // 1962
        _id: {                                                                                                         // 1963
          $in: packageIds                                                                                              // 1964
        },                                                                                                             // 1963
        status: "ready"                                                                                                // 1966
      });                                                                                                              // 1962
      return readyApps.count() === packageIds.length;                                                                  // 1968
    }                                                                                                                  // 1969
                                                                                                                       //
    return isPreinstalledAppsReady;                                                                                    // 1253
  }(),                                                                                                                 // 1253
  getBillingPromptUrl: function () {                                                                                   // 1971
    function getBillingPromptUrl() {                                                                                   // 1253
      var setting = this.collections.settings.findOne({ _id: "billingPromptUrl" });                                    // 1972
      return setting && setting.value;                                                                                 // 1973
    }                                                                                                                  // 1974
                                                                                                                       //
    return getBillingPromptUrl;                                                                                        // 1253
  }(),                                                                                                                 // 1253
  isReferralEnabled: function () {                                                                                     // 1976
    function isReferralEnabled() {                                                                                     // 1253
      // This function is a bit weird, in that we've transitioned from                                                 // 1977
      // Meteor.settings.public.quotaEnabled to DB settings. For now,                                                  // 1978
      // Meteor.settings.public.quotaEnabled implies bothisReferralEnabled and isQuotaEnabled are true.                // 1979
      return Meteor.settings["public"].quotaEnabled;                                                                   // 1980
    }                                                                                                                  // 1981
                                                                                                                       //
    return isReferralEnabled;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  isHideAboutEnabled: function () {                                                                                    // 1983
    function isHideAboutEnabled() {                                                                                    // 1253
      var setting = this.collections.settings.findOne({ _id: "whiteLabelHideAbout" });                                 // 1984
      return setting && setting.value;                                                                                 // 1985
    }                                                                                                                  // 1986
                                                                                                                       //
    return isHideAboutEnabled;                                                                                         // 1253
  }(),                                                                                                                 // 1253
  isQuotaEnabled: function () {                                                                                        // 1988
    function isQuotaEnabled() {                                                                                        // 1253
      if (Meteor.settings["public"].quotaEnabled) return true;                                                         // 1989
                                                                                                                       //
      var setting = this.collections.settings.findOne({ _id: "quotaEnabled" });                                        // 1991
      return setting && setting.value;                                                                                 // 1992
    }                                                                                                                  // 1993
                                                                                                                       //
    return isQuotaEnabled;                                                                                             // 1253
  }(),                                                                                                                 // 1253
  isQuotaLdapEnabled: function () {                                                                                    // 1995
    function isQuotaLdapEnabled() {                                                                                    // 1253
      var setting = this.collections.settings.findOne({ _id: "quotaLdapEnabled" });                                    // 1996
      return setting && setting.value;                                                                                 // 1997
    }                                                                                                                  // 1998
                                                                                                                       //
    return isQuotaLdapEnabled;                                                                                         // 1253
  }(),                                                                                                                 // 1253
  updateUserQuota: function () {                                                                                       // 2000
    function updateUserQuota(user) {                                                                                   // 1253
      if (this.quotaManager) {                                                                                         // 2001
        return this.quotaManager.updateUserQuota(this, user);                                                          // 2002
      }                                                                                                                // 2003
    }                                                                                                                  // 2004
                                                                                                                       //
    return updateUserQuota;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  getUserQuota: function () {                                                                                          // 2006
    function getUserQuota(user) {                                                                                      // 1253
      if (this.isQuotaLdapEnabled()) {                                                                                 // 2007
        return this.quotaManager.updateUserQuota(this, user);                                                          // 2008
      } else {                                                                                                         // 2009
        var plan = this.getPlan(user.plan || "free", user);                                                            // 2010
        var referralBonus = calculateReferralBonus(user);                                                              // 2011
        var bonus = user.planBonus || {};                                                                              // 2012
        var userQuota = {                                                                                              // 2013
          storage: plan.storage + referralBonus.storage + (bonus.storage || 0),                                        // 2014
          grains: plan.grains + referralBonus.grains + (bonus.grains || 0),                                            // 2015
          compute: plan.compute + (bonus.compute || 0)                                                                 // 2016
        };                                                                                                             // 2013
        return userQuota;                                                                                              // 2018
      }                                                                                                                // 2019
    }                                                                                                                  // 2020
                                                                                                                       //
    return getUserQuota;                                                                                               // 1253
  }(),                                                                                                                 // 1253
  isUserOverQuota: function () {                                                                                       // 2022
    function isUserOverQuota(user) {                                                                                   // 1253
      // Return false if user has quota space remaining, true if it is full. When this returns true,                   // 2023
      // we will not allow the user to create new grains, though they may be able to open existing ones                // 2024
      // which may still increase their storage usage.                                                                 // 2025
      //                                                                                                               // 2026
      // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                              // 2027
                                                                                                                       //
      if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                        // 2029
                                                                                                                       //
      var plan = this.getUserQuota(user);                                                                              // 2031
      if (plan.grains < Infinity) {                                                                                    // 2032
        var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: plan.grains }).count();
        if (count >= plan.grains) return "outOfGrains";                                                                // 2035
      }                                                                                                                // 2036
                                                                                                                       //
      return plan && user.storageUsage && user.storageUsage >= plan.storage && "outOfStorage";                         // 2038
    }                                                                                                                  // 2039
                                                                                                                       //
    return isUserOverQuota;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  isUserExcessivelyOverQuota: function () {                                                                            // 2041
    function isUserExcessivelyOverQuota(user) {                                                                        // 1253
      // Return true if user is so far over quota that we should prevent their existing grains from                    // 2042
      // running at all.                                                                                               // 2043
      //                                                                                                               // 2044
      // (Actually returns a string which can be fed into `billingPrompt` as the reason.)                              // 2045
                                                                                                                       //
      if (!this.isQuotaEnabled() || user.isAdmin) return false;                                                        // 2047
                                                                                                                       //
      var quota = this.getUserQuota(user);                                                                             // 2049
                                                                                                                       //
      // quota.grains = Infinity means unlimited grains. IEEE754 defines Infinity == Infinity.                         // 2051
      if (quota.grains < Infinity) {                                                                                   // 2052
        var count = this.collections.grains.find({ userId: user._id, trashed: { $exists: false } }, { fields: {}, limit: quota.grains * 2 }).count();
        if (count >= quota.grains * 2) return "outOfGrains";                                                           // 2055
      }                                                                                                                // 2056
                                                                                                                       //
      return quota && user.storageUsage && user.storageUsage >= quota.storage * 1.2 && "outOfStorage";                 // 2058
    }                                                                                                                  // 2059
                                                                                                                       //
    return isUserExcessivelyOverQuota;                                                                                 // 1253
  }(),                                                                                                                 // 1253
  suspendIdentity: function () {                                                                                       // 2061
    function suspendIdentity(userId, suspension) {                                                                     // 1253
      check(userId, String);                                                                                           // 2062
      check(suspension, {                                                                                              // 2063
        timestamp: Date,                                                                                               // 2064
        admin: Match.Optional(String),                                                                                 // 2065
        voluntary: Match.Optional(Boolean)                                                                             // 2066
      });                                                                                                              // 2063
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                             // 2069
      this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $set: { suspended: true } }, { multi: true });
    }                                                                                                                  // 2072
                                                                                                                       //
    return suspendIdentity;                                                                                            // 1253
  }(),                                                                                                                 // 1253
  unsuspendIdentity: function () {                                                                                     // 2074
    function unsuspendIdentity(userId) {                                                                               // 1253
      check(userId, String);                                                                                           // 2075
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                    // 2077
      this.collections.apiTokens.update({ "owner.user.identityId": userId }, { $unset: { suspended: true } }, { multi: true });
    }                                                                                                                  // 2080
                                                                                                                       //
    return unsuspendIdentity;                                                                                          // 1253
  }(),                                                                                                                 // 1253
  suspendAccount: function () {                                                                                        // 2082
    function suspendAccount(userId, byAdminUserId, willDelete) {                                                       // 1253
      var _this6 = this;                                                                                               // 2082
                                                                                                                       //
      check(userId, String);                                                                                           // 2083
      check(byAdminUserId, Match.OneOf(String, null, undefined));                                                      // 2084
      check(willDelete, Boolean);                                                                                      // 2085
                                                                                                                       //
      var user = this.collections.users.findOne({ _id: userId });                                                      // 2087
      var suspension = {                                                                                               // 2088
        timestamp: new Date(),                                                                                         // 2089
        willDelete: willDelete || false                                                                                // 2090
      };                                                                                                               // 2088
      if (byAdminUserId) {                                                                                             // 2092
        suspension.admin = byAdminUserId;                                                                              // 2093
      } else {                                                                                                         // 2094
        suspension.voluntary = true;                                                                                   // 2095
      }                                                                                                                // 2096
                                                                                                                       //
      this.collections.users.update({ _id: userId }, { $set: { suspended: suspension } });                             // 2098
      this.collections.grains.update({ userId: userId }, { $set: { suspended: true } }, { multi: true });              // 2099
                                                                                                                       //
      delete suspension.willDelete;                                                                                    // 2101
      // Only mark the parent account for deletion. This makes the query simpler later.                                // 2102
                                                                                                                       //
      user.loginIdentities.forEach(function (identity) {                                                               // 2104
        _this6.suspendIdentity(identity.id, suspension);                                                               // 2105
      });                                                                                                              // 2106
      user.nonloginIdentities.forEach(function (identity) {                                                            // 2107
        if (_this6.collections.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
          // Only suspend non-login identities that are unique to this account.                                        // 2112
          _this6.suspendIdentity(identity.id, suspension);                                                             // 2113
        }                                                                                                              // 2114
      });                                                                                                              // 2115
                                                                                                                       //
      // Force logout this user                                                                                        // 2117
      this.collections.users.update({ _id: userId }, { $unset: { "services.resume.loginTokens": 1 } });                // 2118
      if (user && user.loginIdentities) {                                                                              // 2120
        user.loginIdentities.forEach(function (identity) {                                                             // 2121
          Meteor.users.update({ _id: identity.id }, { $unset: { "services.resume.loginTokens": 1 } });                 // 2122
        });                                                                                                            // 2123
      }                                                                                                                // 2124
    }                                                                                                                  // 2125
                                                                                                                       //
    return suspendAccount;                                                                                             // 1253
  }(),                                                                                                                 // 1253
  unsuspendAccount: function () {                                                                                      // 2127
    function unsuspendAccount(userId) {                                                                                // 1253
      var _this7 = this;                                                                                               // 2127
                                                                                                                       //
      check(userId, String);                                                                                           // 2128
                                                                                                                       //
      var user = this.collections.users.findOne({ _id: userId });                                                      // 2130
      this.collections.users.update({ _id: userId }, { $unset: { suspended: 1 } });                                    // 2131
      this.collections.grains.update({ userId: userId }, { $unset: { suspended: 1 } }, { multi: true });               // 2132
                                                                                                                       //
      user.loginIdentities.forEach(function (identity) {                                                               // 2134
        _this7.unsuspendIdentity(identity.id);                                                                         // 2135
      });                                                                                                              // 2136
                                                                                                                       //
      user.nonloginIdentities.forEach(function (identity) {                                                            // 2138
        _this7.unsuspendIdentity(identity.id);                                                                         // 2139
      });                                                                                                              // 2140
    }                                                                                                                  // 2141
                                                                                                                       //
    return unsuspendAccount;                                                                                           // 1253
  }(),                                                                                                                 // 1253
  deletePendingAccounts: function () {                                                                                 // 2143
    function deletePendingAccounts(deletionCoolingOffTime, backend, cb) {                                              // 1253
      var _this8 = this;                                                                                               // 2143
                                                                                                                       //
      check(deletionCoolingOffTime, Number);                                                                           // 2144
                                                                                                                       //
      var queryDate = new Date(Date.now() - deletionCoolingOffTime);                                                   // 2146
      this.collections.users.find({                                                                                    // 2147
        "suspended.willDelete": true,                                                                                  // 2148
        "suspended.timestamp": { $lt: queryDate }                                                                      // 2149
      }).forEach(function (user) {                                                                                     // 2147
        if (cb) cb(_this8, user);                                                                                      // 2151
        _this8.deleteAccount(user._id, backend);                                                                       // 2152
      });                                                                                                              // 2153
    }                                                                                                                  // 2154
                                                                                                                       //
    return deletePendingAccounts;                                                                                      // 1253
  }(),                                                                                                                 // 1253
                                                                                                                       //
                                                                                                                       //
  hostIsStandalone: function () {                                                                                      // 2156
    function hostIsStandalone(hostname) {                                                                              // 2156
      check(hostname, String);                                                                                         // 2157
                                                                                                                       //
      return !!this.collections.standaloneDomains.findOne({ _id: hostname });                                          // 2159
    }                                                                                                                  // 2160
                                                                                                                       //
    return hostIsStandalone;                                                                                           // 2156
  }()                                                                                                                  // 2156
});                                                                                                                    // 1253
                                                                                                                       //
SandstormDb.escapeMongoKey = function (key) {                                                                          // 2163
  // This incredibly poor mechanism for escaping Mongo keys is recommended by the Mongo docs here:                     // 2164
  //   https://docs.mongodb.org/manual/faq/developers/#dollar-sign-operator-escaping                                   // 2165
  // and seems to be a de facto standard, for example:                                                                 // 2166
  //   https://www.npmjs.com/package/mongo-key-escape                                                                  // 2167
  return key.replace(".", "\uFF0E").replace("$", "\uFF04");                                                            // 2168
};                                                                                                                     // 2169
                                                                                                                       //
var appNameFromPackage = function appNameFromPackage(packageObj) {                                                     // 2171
  // This function takes a Package object from Mongo and returns an                                                    // 2172
  // app title.                                                                                                        // 2173
  var manifest = packageObj.manifest;                                                                                  // 2174
  if (!manifest) return packageObj.appId || packageObj._id || "unknown";                                               // 2175
  var action = manifest.actions[0];                                                                                    // 2176
  appName = manifest.appTitle && manifest.appTitle.defaultText || appNameFromActionName(action.title.defaultText);     // 2177
  return appName;                                                                                                      // 2179
};                                                                                                                     // 2180
                                                                                                                       //
var appNameFromActionName = function appNameFromActionName(name) {                                                     // 2182
  // Hack: Historically we only had action titles, like "New Etherpad Document", not app                               // 2183
  //   titles. But for this UI we want app titles. As a transitionary measure, try to                                  // 2184
  //   derive the app title from the action title.                                                                     // 2185
  // TODO(cleanup): Get rid of this once apps have real titles.                                                        // 2186
  if (!name) {                                                                                                         // 2187
    return "(unnamed)";                                                                                                // 2188
  }                                                                                                                    // 2189
                                                                                                                       //
  if (name.lastIndexOf("New ", 0) === 0) {                                                                             // 2191
    name = name.slice(4);                                                                                              // 2192
  }                                                                                                                    // 2193
                                                                                                                       //
  if (name.lastIndexOf("Hacker CMS", 0) === 0) {                                                                       // 2195
    name = "Hacker CMS";                                                                                               // 2196
  } else {                                                                                                             // 2197
    var space = name.indexOf(" ");                                                                                     // 2198
    if (space > 0) {                                                                                                   // 2199
      name = name.slice(0, space);                                                                                     // 2200
    }                                                                                                                  // 2201
  }                                                                                                                    // 2202
                                                                                                                       //
  return name;                                                                                                         // 2204
};                                                                                                                     // 2205
                                                                                                                       //
var appShortDescriptionFromPackage = function appShortDescriptionFromPackage(pkg) {                                    // 2207
  return pkg && pkg.manifest && pkg.manifest.metadata && pkg.manifest.metadata.shortDescription && pkg.manifest.metadata.shortDescription.defaultText;
};                                                                                                                     // 2211
                                                                                                                       //
var nounPhraseForActionAndAppTitle = function nounPhraseForActionAndAppTitle(action, appTitle) {                       // 2213
  // A hack to deal with legacy apps not including fields in their manifests.                                          // 2214
  // I look forward to the day I can remove most of this code.                                                         // 2215
  // Attempt to figure out the appropriate noun that this action will create.                                          // 2216
  // Use an explicit noun phrase is one is available.  Apps should add these in the future.                            // 2217
  if (action.nounPhrase) return action.nounPhrase.defaultText;                                                         // 2218
  // Otherwise, try to guess one from the structure of the action title field                                          // 2219
  if (action.title && action.title.defaultText) {                                                                      // 2220
    var text = action.title.defaultText;                                                                               // 2221
    // Strip a leading "New "                                                                                          // 2222
    if (text.lastIndexOf("New ", 0) === 0) {                                                                           // 2223
      var candidate = text.slice(4);                                                                                   // 2224
      // Strip a leading appname too, if provided                                                                      // 2225
      if (candidate.lastIndexOf(appTitle, 0) === 0) {                                                                  // 2226
        var newCandidate = candidate.slice(appTitle.length);                                                           // 2227
        // Unless that leaves you with no noun, in which case, use "grain"                                             // 2228
        if (newCandidate.length > 0) {                                                                                 // 2229
          return newCandidate.toLowerCase();                                                                           // 2230
        } else {                                                                                                       // 2231
          return "grain";                                                                                              // 2232
        }                                                                                                              // 2233
      }                                                                                                                // 2234
                                                                                                                       //
      return candidate.toLowerCase();                                                                                  // 2236
    }                                                                                                                  // 2237
    // Some other verb phrase was given.  Just use it verbatim, and hope the app author updates                        // 2238
    // the package soon.                                                                                               // 2239
    return text;                                                                                                       // 2240
  } else {                                                                                                             // 2241
    return "grain";                                                                                                    // 2242
  }                                                                                                                    // 2243
};                                                                                                                     // 2244
                                                                                                                       //
// Static methods on SandstormDb that don't need an instance.                                                          // 2246
// Largely things that deal with backwards-compatibility.                                                              // 2247
_.extend(SandstormDb, {                                                                                                // 2248
  appNameFromActionName: appNameFromActionName,                                                                        // 2249
  appNameFromPackage: appNameFromPackage,                                                                              // 2250
  appShortDescriptionFromPackage: appShortDescriptionFromPackage,                                                      // 2251
  nounPhraseForActionAndAppTitle: nounPhraseForActionAndAppTitle                                                       // 2252
});                                                                                                                    // 2248
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2255
  (function () {                                                                                                       // 2255
    var Crypto = Npm.require("crypto");                                                                                // 2256
    var ContentType = Npm.require("content-type");                                                                     // 2257
    var Zlib = Npm.require("zlib");                                                                                    // 2258
    var Url = Npm.require("url");                                                                                      // 2259
                                                                                                                       //
    var replicaNumber = Meteor.settings.replicaNumber || 0;                                                            // 2261
                                                                                                                       //
    var computeStagger = function computeStagger(n) {                                                                  // 2263
      // Compute a fraction in the range [0, 1) such that, for any natural number k, the values                        // 2264
      // of computeStagger(n) for all n in [1, 2^k) are uniformly distributed between 0 and 1.                         // 2265
      // The sequence looks like:                                                                                      // 2266
      //   0, 1/2, 1/4, 3/4, 1/8, 3/8, 5/8, 7/8, 1/16, ...                                                             // 2267
      //                                                                                                               // 2268
      // We use this to determine how we'll stagger periodic events performed by this replica.                         // 2269
      // Notice that this allows us to compute a stagger which is independent of the number of                         // 2270
      // front-end replicas present; we can add more replicas to the end without affecting how the                     // 2271
      // earlier ones schedule their events.                                                                           // 2272
      var denom = 1;                                                                                                   // 2273
      while (denom <= n) {                                                                                             // 2274
        denom <<= 1;                                                                                                   // 2274
      }var num = n * 2 - denom + 1;                                                                                    // 2274
      return num / denom;                                                                                              // 2276
    };                                                                                                                 // 2277
                                                                                                                       //
    var stagger = computeStagger(replicaNumber);                                                                       // 2279
                                                                                                                       //
    SandstormDb.periodicCleanup = function (intervalMs, callback) {                                                    // 2281
      // Register a database cleanup function than should run periodically, roughly once every                         // 2282
      // interval of the given length.                                                                                 // 2283
      //                                                                                                               // 2284
      // In a blackrock deployment with multiple front-ends, the frequency of the cleanup will be                      // 2285
      // scaled appropriately on the assumption that more data is being generated demanding more                       // 2286
      // frequent cleanups.                                                                                            // 2287
                                                                                                                       //
      check(intervalMs, Number);                                                                                       // 2289
      check(callback, Function);                                                                                       // 2290
                                                                                                                       //
      if (intervalMs < 120000) {                                                                                       // 2292
        throw new Error("less than 2-minute cleanup interval seems too fast; " + "are you using the right units?");    // 2293
      }                                                                                                                // 2295
                                                                                                                       //
      // Schedule first cleanup to happen at the next intervalMs interval from the epoch, so that                      // 2297
      // the schedule is independent of the exact startup time.                                                        // 2298
      var first = intervalMs - Date.now() % intervalMs;                                                                // 2299
                                                                                                                       //
      // Stagger cleanups across replicas so that we don't have all replicas trying to clean the                       // 2301
      // same data at the same time.                                                                                   // 2302
      first += Math.floor(intervalMs * computeStagger(replicaNumber));                                                 // 2303
                                                                                                                       //
      // If the stagger put us more than an interval away from now, back up.                                           // 2305
      if (first > intervalMs) first -= intervalMs;                                                                     // 2306
                                                                                                                       //
      Meteor.setTimeout(function () {                                                                                  // 2308
        callback();                                                                                                    // 2309
        Meteor.setInterval(callback, intervalMs);                                                                      // 2310
      }, first);                                                                                                       // 2311
    };                                                                                                                 // 2312
                                                                                                                       //
    // TODO(cleanup): Node 0.12 has a `gzipSync` but 0.10 (which Meteor still uses) does not.                          // 2314
    var gzipSync = Meteor.wrapAsync(Zlib.gzip, Zlib);                                                                  // 2315
                                                                                                                       //
    var BufferSmallerThan = function BufferSmallerThan(limit) {                                                        // 2317
      return Match.Where(function (buf) {                                                                              // 2318
        check(buf, Buffer);                                                                                            // 2319
        return buf.length < limit;                                                                                     // 2320
      });                                                                                                              // 2321
    };                                                                                                                 // 2322
                                                                                                                       //
    var DatabaseId = Match.Where(function (s) {                                                                        // 2324
      check(s, String);                                                                                                // 2325
      return !!s.match(/^[a-zA-Z0-9_]+$/);                                                                             // 2326
    });                                                                                                                // 2327
                                                                                                                       //
    SandstormDb.prototype.addStaticAsset = function (metadata, content) {                                              // 2329
      // Add a new static asset to the database. If `content` is a string rather than a buffer, it                     // 2330
      // will be automatically gzipped before storage; do not specify metadata.encoding in this case.                  // 2331
                                                                                                                       //
      if (typeof content === "string" && !metadata.encoding) {                                                         // 2333
        content = gzipSync(new Buffer(content, "utf8"));                                                               // 2334
        metadata.encoding = "gzip";                                                                                    // 2335
      }                                                                                                                // 2336
                                                                                                                       //
      check(metadata, {                                                                                                // 2338
        mimeType: String,                                                                                              // 2339
        encoding: Match.Optional("gzip")                                                                               // 2340
      });                                                                                                              // 2338
      check(content, BufferSmallerThan(1 << 20));                                                                      // 2342
                                                                                                                       //
      // Validate content type.                                                                                        // 2344
      metadata.mimeType = ContentType.format(ContentType.parse(metadata.mimeType));                                    // 2345
                                                                                                                       //
      var hasher = Crypto.createHash("sha256");                                                                        // 2347
      hasher.update(metadata.mimeType + "\n" + metadata.encoding + "\n", "utf8");                                      // 2348
      hasher.update(content);                                                                                          // 2349
      var hash = hasher.digest("base64");                                                                              // 2350
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2352
        query: { hash: hash, refcount: { $gte: 1 } },                                                                  // 2353
        update: { $inc: { refcount: 1 } },                                                                             // 2354
        fields: { _id: 1, refcount: 1 }                                                                                // 2355
      });                                                                                                              // 2352
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2358
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2359
      }                                                                                                                // 2360
                                                                                                                       //
      var existing = result.value;                                                                                     // 2362
      if (existing) {                                                                                                  // 2363
        return existing._id;                                                                                           // 2364
      }                                                                                                                // 2365
                                                                                                                       //
      return this.collections.staticAssets.insert(_.extend({                                                           // 2367
        hash: hash,                                                                                                    // 2368
        content: content,                                                                                              // 2369
        refcount: 1                                                                                                    // 2370
      }, metadata));                                                                                                   // 2367
    };                                                                                                                 // 2372
                                                                                                                       //
    SandstormDb.prototype.refStaticAsset = function (id) {                                                             // 2374
      // Increment the refcount on an existing static asset. Returns the asset on success.                             // 2375
      // If the asset does not exist, returns a falsey value.                                                          // 2376
      //                                                                                                               // 2377
      // You must call this BEFORE adding the new reference to the DB, in case of failure between                      // 2378
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     // 2379
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       // 2380
                                                                                                                       //
      check(id, String);                                                                                               // 2382
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2384
        query: { hash: hash },                                                                                         // 2385
        update: { $inc: { refcount: 1 } },                                                                             // 2386
        fields: { _id: 1, content: 1, mimeType: 1 }                                                                    // 2387
      });                                                                                                              // 2384
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2390
        throw new Error("Couldn't increment refcount of asset with hash " + hash);                                     // 2391
      }                                                                                                                // 2392
                                                                                                                       //
      var existing = result.value;                                                                                     // 2394
      return existing;                                                                                                 // 2395
    };                                                                                                                 // 2396
                                                                                                                       //
    SandstormDb.prototype.unrefStaticAsset = function (id) {                                                           // 2398
      // Decrement refcount on a static asset and delete if it has reached zero.                                       // 2399
      //                                                                                                               // 2400
      // You must call this AFTER removing the reference from the DB, in case of failure between                       // 2401
      // the two calls. (This way, the failure case is a storage leak, which is probably not a big                     // 2402
      // deal and can be fixed by GC, rather than a mysteriously missing asset.)                                       // 2403
                                                                                                                       //
      check(id, String);                                                                                               // 2405
                                                                                                                       //
      var result = this.collections.staticAssets.findAndModify({                                                       // 2407
        query: { _id: id },                                                                                            // 2408
        update: { $inc: { refcount: -1 } },                                                                            // 2409
        fields: { _id: 1, refcount: 1 },                                                                               // 2410
        "new": true                                                                                                    // 2411
      });                                                                                                              // 2407
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2414
        throw new Error("Couldn't unref static asset " + id);                                                          // 2415
      }                                                                                                                // 2416
                                                                                                                       //
      var existing = result.value;                                                                                     // 2418
      if (!existing) {                                                                                                 // 2419
        console.error(new Error("unrefStaticAsset() called on asset that doesn't exist").stack);                       // 2420
      } else if (existing.refcount <= 0) {                                                                             // 2421
        this.collections.staticAssets.remove({ _id: existing._id });                                                   // 2422
      }                                                                                                                // 2423
    };                                                                                                                 // 2424
                                                                                                                       //
    SandstormDb.prototype.getStaticAsset = function (id) {                                                             // 2426
      // Get a static asset's mimeType, encoding, and raw content.                                                     // 2427
                                                                                                                       //
      check(id, String);                                                                                               // 2429
                                                                                                                       //
      var asset = this.collections.staticAssets.findOne(id, { fields: { _id: 0, mimeType: 1, encoding: 1, content: 1 } });
      if (asset) {                                                                                                     // 2432
        // TODO(perf): Mongo converts buffers to something else. Figure out a way to avoid a copy                      // 2433
        //   here.                                                                                                     // 2434
        asset.content = new Buffer(asset.content);                                                                     // 2435
      }                                                                                                                // 2436
                                                                                                                       //
      return asset;                                                                                                    // 2438
    };                                                                                                                 // 2439
                                                                                                                       //
    SandstormDb.prototype.newAssetUpload = function (purpose) {                                                        // 2441
      check(purpose, Match.OneOf({ profilePicture: { userId: DatabaseId, identityId: DatabaseId } }, { loginLogo: {} }));
                                                                                                                       //
      return this.collections.assetUploadTokens.insert({                                                               // 2447
        purpose: purpose,                                                                                              // 2448
        expires: new Date(Date.now() + 300000) });                                                                     // 2449
    };                                                                                                                 // 2451
                                                                                                                       //
    SandstormDb.prototype.fulfillAssetUpload = function (id) {                                                         // 2453
      // Indicates that the given asset upload has completed. It will be removed and its purpose                       // 2454
      // returned. If no matching upload exists, returns undefined.                                                    // 2455
                                                                                                                       //
      check(id, String);                                                                                               // 2457
                                                                                                                       //
      var result = this.collections.assetUploadTokens.findAndModify({                                                  // 2459
        query: { _id: id },                                                                                            // 2460
        remove: true                                                                                                   // 2461
      });                                                                                                              // 2459
                                                                                                                       //
      if (!result.ok) {                                                                                                // 2464
        throw new Error("Failed to remove asset upload token");                                                        // 2465
      }                                                                                                                // 2466
                                                                                                                       //
      var upload = result.value;                                                                                       // 2468
                                                                                                                       //
      if (upload.expires.valueOf() < Date.now()) {                                                                     // 2470
        return undefined; // already expired                                                                           // 2471
      } else {                                                                                                         // 2472
        return upload.purpose;                                                                                         // 2473
      }                                                                                                                // 2474
    };                                                                                                                 // 2475
                                                                                                                       //
    SandstormDb.prototype.cleanupExpiredAssetUploads = function () {                                                   // 2477
      this.collections.assetUploadTokens.remove({ expires: { $lt: Date.now() } });                                     // 2478
    };                                                                                                                 // 2479
                                                                                                                       //
    // TODO(cleanup): lift this out of the package so it can share with the ones in async-helpers.js                   // 2481
    var Future = Npm.require("fibers/future");                                                                         // 2482
    var promiseToFuture = function promiseToFuture(promise) {                                                          // 2483
      var result = new Future();                                                                                       // 2484
      promise.then(result["return"].bind(result), result["throw"].bind(result));                                       // 2485
      return result;                                                                                                   // 2486
    };                                                                                                                 // 2487
                                                                                                                       //
    var waitPromise = function waitPromise(promise) {                                                                  // 2489
      return promiseToFuture(promise).wait();                                                                          // 2490
    };                                                                                                                 // 2491
                                                                                                                       //
    SandstormDb.prototype.deleteGrains = function (query, backend, type) {                                             // 2493
      var _this9 = this;                                                                                               // 2493
                                                                                                                       //
      // Returns the number of grains deleted.                                                                         // 2494
                                                                                                                       //
      check(type, Match.OneOf("grain", "demoGrain"));                                                                  // 2496
                                                                                                                       //
      var numDeleted = 0;                                                                                              // 2498
      this.collections.grains.find(query).forEach(function (grain) {                                                   // 2499
        var user = Meteor.users.findOne(grain.userId);                                                                 // 2500
                                                                                                                       //
        waitPromise(backend.deleteGrain(grain._id, grain.userId));                                                     // 2502
        numDeleted += _this9.collections.grains.remove({ _id: grain._id });                                            // 2503
        _this9.removeApiTokens({                                                                                       // 2504
          grainId: grain._id,                                                                                          // 2505
          $or: [{ owner: { $exists: false } }, { owner: { webkey: null } }]                                            // 2506
        });                                                                                                            // 2504
                                                                                                                       //
        _this9.removeApiTokens({ "owner.grain.grainId": grain._id });                                                  // 2512
                                                                                                                       //
        _this9.collections.activitySubscriptions.remove({ grainId: grain._id });                                       // 2514
                                                                                                                       //
        if (grain.lastUsed) {                                                                                          // 2516
          var record = {                                                                                               // 2517
            type: "grain", // Demo grains can never get here!                                                          // 2518
            lastActive: grain.lastUsed,                                                                                // 2519
            appId: grain.appId                                                                                         // 2520
          };                                                                                                           // 2517
          if (user && user.experiments) {                                                                              // 2522
            record.experiments = user.experiments;                                                                     // 2523
          }                                                                                                            // 2524
                                                                                                                       //
          _this9.collections.deleteStats.insert(record);                                                               // 2526
        }                                                                                                              // 2527
                                                                                                                       //
        _this9.deleteUnusedPackages(grain.appId);                                                                      // 2529
                                                                                                                       //
        if (grain.size) {                                                                                              // 2531
          Meteor.users.update(grain.userId, { $inc: { storageUsage: -grain.size } });                                  // 2532
        }                                                                                                              // 2533
      });                                                                                                              // 2534
      return numDeleted;                                                                                               // 2535
    };                                                                                                                 // 2536
                                                                                                                       //
    SandstormDb.prototype.userGrainTitle = function (grainId, accountId, identityId) {                                 // 2538
      check(grainId, String);                                                                                          // 2539
      check(accountId, Match.OneOf(String, undefined, null));                                                          // 2540
      check(identityId, String);                                                                                       // 2541
                                                                                                                       //
      var grain = this.getGrain(grainId);                                                                              // 2543
      if (!grain) {                                                                                                    // 2544
        throw new Error("called userGrainTitle() for a grain that doesn't exist");                                     // 2545
      }                                                                                                                // 2546
                                                                                                                       //
      var title = grain.title;                                                                                         // 2548
      if (grain.userId !== accountId) {                                                                                // 2549
        var sharerToken = this.collections.apiTokens.findOne({                                                         // 2550
          grainId: grainId,                                                                                            // 2551
          "owner.user.identityId": identityId                                                                          // 2552
        }, {                                                                                                           // 2550
          sort: {                                                                                                      // 2554
            lastUsed: -1                                                                                               // 2555
          }                                                                                                            // 2554
        });                                                                                                            // 2553
        if (sharerToken) {                                                                                             // 2558
          title = sharerToken.owner.user.title;                                                                        // 2559
        } else {                                                                                                       // 2560
          title = "shared grain";                                                                                      // 2561
        }                                                                                                              // 2562
      }                                                                                                                // 2563
                                                                                                                       //
      return title;                                                                                                    // 2565
    };                                                                                                                 // 2566
                                                                                                                       //
    var packageCache = {};                                                                                             // 2568
    // Package info is immutable. Let's cache to save on mongo queries.                                                // 2569
                                                                                                                       //
    SandstormDb.prototype.getPackage = function (packageId) {                                                          // 2571
      // Get the given package record. Since package info is immutable, cache the data in the server                   // 2572
      // to reduce mongo query overhead, since it turns out we have to fetch specific packages a                       // 2573
      // lot.                                                                                                          // 2574
                                                                                                                       //
      if (packageId in packageCache) {                                                                                 // 2576
        return packageCache[packageId];                                                                                // 2577
      }                                                                                                                // 2578
                                                                                                                       //
      var pkg = this.collections.packages.findOne(packageId);                                                          // 2580
      if (pkg && pkg.status === "ready") {                                                                             // 2581
        packageCache[packageId] = pkg;                                                                                 // 2582
      }                                                                                                                // 2583
                                                                                                                       //
      return pkg;                                                                                                      // 2585
    };                                                                                                                 // 2586
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedPackages = function (appId) {                                                    // 2588
      var _this10 = this;                                                                                              // 2588
                                                                                                                       //
      check(appId, String);                                                                                            // 2589
      this.collections.packages.find({ appId: appId }).forEach(function (pkg) {                                        // 2590
        // Mark package for possible deletion;                                                                         // 2591
        _this10.collections.packages.update({ _id: pkg._id, status: "ready" }, { $set: { shouldCleanup: true } });     // 2592
      });                                                                                                              // 2593
    };                                                                                                                 // 2594
                                                                                                                       //
    SandstormDb.prototype.sendAppUpdateNotifications = function (appId, packageId, name, versionNumber, marketingVersion) {
      var _this11 = this;                                                                                              // 2597
                                                                                                                       //
      var actions = this.collections.userActions.find({ appId: appId, appVersion: { $lt: versionNumber } }, { fields: { userId: 1 } });
      actions.forEach(function (action) {                                                                              // 2600
        var userId = action.userId;                                                                                    // 2601
        var updater = {                                                                                                // 2602
          timestamp: new Date(),                                                                                       // 2603
          isUnread: true                                                                                               // 2604
        };                                                                                                             // 2602
        var inserter = _.extend({ userId: userId, appUpdates: {} }, updater);                                          // 2606
                                                                                                                       //
        // Set only the appId that we care about. Use mongo's dot notation to specify only a single                    // 2608
        // field inside of an object to update                                                                         // 2609
        inserter.appUpdates[appId] = updater["appUpdates." + appId] = {                                                // 2610
          marketingVersion: marketingVersion,                                                                          // 2611
          packageId: packageId,                                                                                        // 2612
          name: name,                                                                                                  // 2613
          version: versionNumber                                                                                       // 2614
        };                                                                                                             // 2610
                                                                                                                       //
        // We unfortunately cannot upsert because upserts can only have field equality conditions in                   // 2617
        // the query. If we try to upsert, Mongo complaints that "$exists" isn't valid to store.                       // 2618
        if (_this11.collections.notifications.update({ userId: userId, appUpdates: { $exists: true } }, { $set: updater }) == 0) {
          // Update failed; try an insert instead.                                                                     // 2622
          _this11.collections.notifications.insert(inserter);                                                          // 2623
        }                                                                                                              // 2624
      });                                                                                                              // 2625
                                                                                                                       //
      this.collections.appIndex.update({ _id: appId }, { $set: { hasSentNotifications: true } });                      // 2627
                                                                                                                       //
      // In the case where we replaced a previous notification and that was the only reference to the                  // 2629
      // package, we need to clean it up                                                                               // 2630
      this.deleteUnusedPackages(appId);                                                                                // 2631
    };                                                                                                                 // 2632
                                                                                                                       //
    SandstormDb.prototype.sendReferralProgramNotification = function (userId) {                                        // 2634
      this.collections.notifications.upsert({                                                                          // 2635
        userId: userId,                                                                                                // 2636
        referral: true                                                                                                 // 2637
      }, {                                                                                                             // 2635
        userId: userId,                                                                                                // 2639
        referral: true,                                                                                                // 2640
        timestamp: new Date(),                                                                                         // 2641
        isUnread: true                                                                                                 // 2642
      });                                                                                                              // 2638
    };                                                                                                                 // 2644
                                                                                                                       //
    SandstormDb.prototype.upgradeGrains = function (appId, version, packageId, backend) {                              // 2646
      check(appId, String);                                                                                            // 2647
      check(version, Match.Integer);                                                                                   // 2648
      check(packageId, String);                                                                                        // 2649
                                                                                                                       //
      var selector = {                                                                                                 // 2651
        userId: Meteor.userId(),                                                                                       // 2652
        appId: appId,                                                                                                  // 2653
        appVersion: { $lte: version },                                                                                 // 2654
        packageId: { $ne: packageId }                                                                                  // 2655
      };                                                                                                               // 2651
                                                                                                                       //
      this.collections.grains.find(selector).forEach(function (grain) {                                                // 2658
        backend.shutdownGrain(grain._id, grain.userId);                                                                // 2659
      });                                                                                                              // 2660
                                                                                                                       //
      this.collections.grains.update(selector, {                                                                       // 2662
        $set: { appVersion: version, packageId: packageId, packageSalt: Random.secret() }                              // 2663
      }, { multi: true });                                                                                             // 2662
    };                                                                                                                 // 2665
                                                                                                                       //
    SandstormDb.prototype.startInstall = function (packageId, url, retryFailed, isAutoUpdated) {                       // 2667
      // Mark package for possible installation.                                                                       // 2668
                                                                                                                       //
      var fields = {                                                                                                   // 2670
        status: "download",                                                                                            // 2671
        progress: 0,                                                                                                   // 2672
        url: url,                                                                                                      // 2673
        isAutoUpdated: !!isAutoUpdated                                                                                 // 2674
      };                                                                                                               // 2670
                                                                                                                       //
      if (retryFailed) {                                                                                               // 2677
        this.collections.packages.update({ _id: packageId, status: "failed" }, { $set: fields });                      // 2678
      } else {                                                                                                         // 2679
        try {                                                                                                          // 2680
          fields._id = packageId;                                                                                      // 2681
          this.collections.packages.insert(fields);                                                                    // 2682
        } catch (err) {                                                                                                // 2683
          console.error("Simultaneous startInstall()s?", err.stack);                                                   // 2684
        }                                                                                                              // 2685
      }                                                                                                                // 2686
    };                                                                                                                 // 2687
                                                                                                                       //
    var ValidKeyFingerprint = Match.Where(function (keyFingerprint) {                                                  // 2689
      check(keyFingerprint, String);                                                                                   // 2690
      return !!keyFingerprint.match(/^[0-9A-F]{40}$/);                                                                 // 2691
    });                                                                                                                // 2692
                                                                                                                       //
    SandstormDb.prototype.updateKeybaseProfileAsync = function (keyFingerprint) {                                      // 2694
      var _this12 = this;                                                                                              // 2694
                                                                                                                       //
      // Asynchronously fetch the given Keybase profile and populate the KeybaseProfiles collection.                   // 2695
                                                                                                                       //
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2697
                                                                                                                       //
      console.log("fetching keybase", keyFingerprint);                                                                 // 2699
                                                                                                                       //
      HTTP.get("https://keybase.io/_/api/1.0/user/lookup.json?key_fingerprint=" + keyFingerprint + "&fields=basics,profile,proofs_summary", {
        timeout: 5000                                                                                                  // 2704
      }, function (err, keybaseResponse) {                                                                             // 2703
        if (err) {                                                                                                     // 2706
          console.log("keybase lookup error:", err.stack);                                                             // 2707
          return;                                                                                                      // 2708
        }                                                                                                              // 2709
                                                                                                                       //
        if (!keybaseResponse.data) {                                                                                   // 2711
          console.log("keybase didn't return JSON? Headers:", keybaseResponse.headers);                                // 2712
          return;                                                                                                      // 2713
        }                                                                                                              // 2714
                                                                                                                       //
        var profile = (keybaseResponse.data.them || [])[0];                                                            // 2716
                                                                                                                       //
        if (profile) {                                                                                                 // 2718
          // jscs:disable requireCamelCaseOrUpperCaseIdentifiers                                                       // 2719
          var record = {                                                                                               // 2720
            displayName: (profile.profile || {}).full_name,                                                            // 2721
            handle: (profile.basics || {}).username,                                                                   // 2722
            proofs: (profile.proofs_summary || {}).all || []                                                           // 2723
          };                                                                                                           // 2720
          // jscs:enable requireCamelCaseOrUpperCaseIdentifiers                                                        // 2725
                                                                                                                       //
          record.proofs.forEach(function (proof) {                                                                     // 2727
            // Remove potentially Mongo-incompatible stuff. (Currently Keybase returns nothing that                    // 2728
            // this would filter.)                                                                                     // 2729
            for (var field in meteorBabelHelpers.sanitizeForInObject(proof)) {                                         // 2730
              // Don't allow field names containing '.' or '$'. Also don't allow sub-objects mainly                    // 2731
              // because I'm too lazy to check the field names recursively (and Keybase doesn't                        // 2732
              // return any objects anyway).                                                                           // 2733
              if (field.match(/[.$]/) || _typeof(proof[field]) === "object") {                                         // 2734
                delete proof[field];                                                                                   // 2735
              }                                                                                                        // 2736
            }                                                                                                          // 2737
                                                                                                                       //
            // Indicate not verified.                                                                                  // 2739
            // TODO(security): Asynchronously verify proofs. Presumably we can borrow code from the                    // 2740
            //   Keybase node-based CLI.                                                                               // 2741
            proof.status = "unverified";                                                                               // 2742
          });                                                                                                          // 2743
                                                                                                                       //
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $set: record }, { upsert: true });              // 2745
        } else {                                                                                                       // 2746
          // Keybase reports no match, so remove what we know of this user. We don't want to remove                    // 2747
          // the item entirely from the cache as this will cause us to repeatedly re-fetch the data                    // 2748
          // from Keybase.                                                                                             // 2749
          //                                                                                                           // 2750
          // TODO(someday): We could perhaps keep the proofs if we can still verify them directly,                     // 2751
          //   but at present we don't have the ability to verify proofs.                                              // 2752
          _this12.collections.keybaseProfiles.update(keyFingerprint, { $unset: { displayName: "", handle: "", proofs: "" } }, { upsert: true });
        }                                                                                                              // 2755
      });                                                                                                              // 2756
    };                                                                                                                 // 2757
                                                                                                                       //
    SandstormDb.prototype.deleteUnusedAccount = function (backend, identityId) {                                       // 2759
      // If there is an *unused* account that has `identityId` as a login identity, deletes it.                        // 2760
                                                                                                                       //
      check(identityId, String);                                                                                       // 2762
      var account = this.collections.users.findOne({ "loginIdentities.id": identityId });                              // 2763
      if (account && account.loginIdentities.length == 1 && account.nonloginIdentities.length == 0 && !this.collections.grains.findOne({ userId: account._id }) && !this.collections.apiTokens.findOne({ accountId: account._id }) && (!account.plan || account.plan === "free") && !(account.payments && account.payments.id) && !this.collections.contacts.findOne({ ownerId: account._id })) {
        this.collections.users.remove({ _id: account._id });                                                           // 2772
        backend.deleteUser(account._id);                                                                               // 2773
      }                                                                                                                // 2774
    };                                                                                                                 // 2775
                                                                                                                       //
    Meteor.publish("keybaseProfile", function (keyFingerprint) {                                                       // 2777
      check(keyFingerprint, ValidKeyFingerprint);                                                                      // 2778
      var db = this.connection.sandstormDb;                                                                            // 2779
                                                                                                                       //
      var cursor = db.collections.keybaseProfiles.find(keyFingerprint);                                                // 2781
      if (cursor.count() === 0) {                                                                                      // 2782
        // Fire off async update.                                                                                      // 2783
        db.updateKeybaseProfileAsync(keyFingerprint);                                                                  // 2784
      }                                                                                                                // 2785
                                                                                                                       //
      return cursor;                                                                                                   // 2787
    });                                                                                                                // 2788
                                                                                                                       //
    Meteor.publish("appIndex", function (appId) {                                                                      // 2790
      check(appId, String);                                                                                            // 2791
      var db = this.connection.sandstormDb;                                                                            // 2792
      var cursor = db.collections.appIndex.find({ _id: appId });                                                       // 2793
      return cursor;                                                                                                   // 2794
    });                                                                                                                // 2795
                                                                                                                       //
    Meteor.publish("userPackages", function () {                                                                       // 2797
      var _this13 = this;                                                                                              // 2797
                                                                                                                       //
      // Users should be able to see packages that are either:                                                         // 2798
      // 1. referenced by one of their userActions                                                                     // 2799
      // 2. referenced by one of their grains                                                                          // 2800
      var db = this.connection.sandstormDb;                                                                            // 2801
                                                                                                                       //
      // Note that package information, once it is in the database, is static. There's no need to                      // 2803
      // reactively subscribe to changes to a package since they don't change. It's also unecessary                    // 2804
      // to reactively remove a package from the client side when it is removed on the server, or                      // 2805
      // when the client stops using it, because the worst case is the client has a small amount                       // 2806
      // of extra info on a no-longer-used package held in memory until they refresh Sandstorm.                        // 2807
      // So, we implement this as a cache: the first time each package ID shows up among the user's                    // 2808
      // stuff, we push the package info to the client, and then we never update it.                                   // 2809
      //                                                                                                               // 2810
      // Alternatively, we could subscribe to each individual package query, but this would waste                      // 2811
      // lots of server-side resources watching for events that will never happen or don't matter.                     // 2812
      var hasPackage = {};                                                                                             // 2813
      var refPackage = function refPackage(packageId) {                                                                // 2814
        // Ignore dev apps.                                                                                            // 2815
        if (packageId.lastIndexOf("dev-", 0) === 0) return;                                                            // 2816
                                                                                                                       //
        if (!hasPackage[packageId]) {                                                                                  // 2818
          hasPackage[packageId] = true;                                                                                // 2819
          var pkg = db.getPackage(packageId);                                                                          // 2820
          if (pkg) {                                                                                                   // 2821
            _this13.added("packages", packageId, pkg);                                                                 // 2822
          } else {                                                                                                     // 2823
            console.error("shouldn't happen: missing package referenced by user's stuff:", packageId);                 // 2824
          }                                                                                                            // 2826
        }                                                                                                              // 2827
      };                                                                                                               // 2828
                                                                                                                       //
      // package source 1: packages referred to by actions                                                             // 2830
      var actions = db.userActions(this.userId);                                                                       // 2831
      var actionsHandle = actions.observe({                                                                            // 2832
        added: function () {                                                                                           // 2833
          function added(newAction) {                                                                                  // 2832
            refPackage(newAction.packageId);                                                                           // 2834
          }                                                                                                            // 2835
                                                                                                                       //
          return added;                                                                                                // 2832
        }(),                                                                                                           // 2832
        changed: function () {                                                                                         // 2837
          function changed(newAction, oldAction) {                                                                     // 2832
            refPackage(newAction.packageId);                                                                           // 2838
          }                                                                                                            // 2839
                                                                                                                       //
          return changed;                                                                                              // 2832
        }()                                                                                                            // 2832
      });                                                                                                              // 2832
                                                                                                                       //
      // package source 2: packages referred to by grains directly                                                     // 2842
      var grains = db.userGrains(this.userId, { includeTrash: true });                                                 // 2843
      var grainsHandle = grains.observe({                                                                              // 2844
        added: function () {                                                                                           // 2845
          function added(newGrain) {                                                                                   // 2844
            // Watch out: DevApp grains can lack a packageId.                                                          // 2846
            if (newGrain.packageId) {                                                                                  // 2847
              refPackage(newGrain.packageId);                                                                          // 2848
            }                                                                                                          // 2849
          }                                                                                                            // 2850
                                                                                                                       //
          return added;                                                                                                // 2844
        }(),                                                                                                           // 2844
        changed: function () {                                                                                         // 2852
          function changed(newGrain, oldGrain) {                                                                       // 2844
            // Watch out: DevApp grains can lack a packageId.                                                          // 2853
            if (newGrain.packageId) {                                                                                  // 2854
              refPackage(newGrain.packageId);                                                                          // 2855
            }                                                                                                          // 2856
          }                                                                                                            // 2857
                                                                                                                       //
          return changed;                                                                                              // 2844
        }()                                                                                                            // 2844
      });                                                                                                              // 2844
                                                                                                                       //
      this.onStop(function () {                                                                                        // 2860
        actionsHandle.stop();                                                                                          // 2861
        grainsHandle.stop();                                                                                           // 2862
      });                                                                                                              // 2863
                                                                                                                       //
      this.ready();                                                                                                    // 2865
    });                                                                                                                // 2866
  })();                                                                                                                // 2255
}                                                                                                                      // 2867
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 2869
  SandstormDb.prototype.deleteIdentity = function (identityId) {                                                       // 2870
    check(identityId, String);                                                                                         // 2871
                                                                                                                       //
    this.removeApiTokens({ "owner.user.identityId": identityId });                                                     // 2873
    this.collections.contacts.remove({ identityId: identityId });                                                      // 2874
    Meteor.users.remove({ _id: identityId });                                                                          // 2875
  };                                                                                                                   // 2876
                                                                                                                       //
  SandstormDb.prototype.deleteAccount = function (userId, backend) {                                                   // 2878
    check(userId, String);                                                                                             // 2879
                                                                                                                       //
    var _this = this;                                                                                                  // 2881
    var user = Meteor.users.findOne({ _id: userId });                                                                  // 2882
    this.deleteGrains({ userId: userId }, backend, "grain");                                                           // 2883
    this.collections.userActions.remove({ userId: userId });                                                           // 2884
    this.collections.notifications.remove({ userId: userId });                                                         // 2885
    user.loginIdentities.forEach(function (identity) {                                                                 // 2886
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               // 2891
        _this.deleteIdentity(identity.id);                                                                             // 2892
      }                                                                                                                // 2893
    });                                                                                                                // 2894
    user.nonloginIdentities.forEach(function (identity) {                                                              // 2895
      if (Meteor.users.find({ $or: [{ "loginIdentities.id": identity.id }, { "nonloginIdentities.id": identity.id }] }).count() === 1) {
        // If this is the only account with the identity, then delete it                                               // 2900
        _this.deleteIdentity(identity.id);                                                                             // 2901
      }                                                                                                                // 2902
    });                                                                                                                // 2903
    this.collections.contacts.remove({ ownerId: userId });                                                             // 2904
    backend.deleteUser(userId);                                                                                        // 2905
    Meteor.users.remove({ _id: userId });                                                                              // 2906
  };                                                                                                                   // 2907
}                                                                                                                      // 2908
                                                                                                                       //
Meteor.methods({                                                                                                       // 2910
  addUserActions: function () {                                                                                        // 2911
    function addUserActions(packageId) {                                                                               // 2910
      check(packageId, String);                                                                                        // 2912
      if (!this.userId || !Meteor.user().loginIdentities || !isSignedUpOrDemo()) {                                     // 2913
        throw new Meteor.Exception(403, "Must be logged in as a non-guest to add app actions.");                       // 2914
      }                                                                                                                // 2915
                                                                                                                       //
      if (this.isSimulation) {                                                                                         // 2917
        // TODO(cleanup): Appdemo code relies on this being simulated client-side but we don't have                    // 2918
        //   a proper DB object to use.                                                                                // 2919
        new SandstormDb().addUserActions(this.userId, packageId, true);                                                // 2920
      } else {                                                                                                         // 2921
        this.connection.sandstormDb.addUserActions(this.userId, packageId);                                            // 2922
      }                                                                                                                // 2923
    }                                                                                                                  // 2924
                                                                                                                       //
    return addUserActions;                                                                                             // 2910
  }(),                                                                                                                 // 2910
  removeUserAction: function () {                                                                                      // 2926
    function removeUserAction(actionId) {                                                                              // 2910
      check(actionId, String);                                                                                         // 2927
      if (this.isSimulation) {                                                                                         // 2928
        UserActions.remove({ _id: actionId });                                                                         // 2929
      } else {                                                                                                         // 2930
        if (this.userId) {                                                                                             // 2931
          var result = this.connection.sandstormDb.collections.userActions.findAndModify({                             // 2932
            query: { _id: actionId, userId: this.userId },                                                             // 2933
            remove: true                                                                                               // 2934
          });                                                                                                          // 2932
                                                                                                                       //
          if (!result.ok) {                                                                                            // 2937
            throw new Error("Couldn't remove user action " + actionId);                                                // 2938
          }                                                                                                            // 2939
                                                                                                                       //
          var action = result.value;                                                                                   // 2941
          if (action) {                                                                                                // 2942
            this.connection.sandstormDb.deleteUnusedPackages(action.appId);                                            // 2943
          }                                                                                                            // 2944
        }                                                                                                              // 2945
      }                                                                                                                // 2946
    }                                                                                                                  // 2947
                                                                                                                       //
    return removeUserAction;                                                                                           // 2910
  }()                                                                                                                  // 2910
});                                                                                                                    // 2910
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}],"profile.js":["babel-runtime/helpers/typeof",function(require,exports,module){

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                                                                                     //
// packages/sandstorm-db/profile.js                                                                                    //
//                                                                                                                     //
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
                                                                                                                       //
var _typeof;module.import("babel-runtime/helpers/typeof",{"default":function(v){_typeof=v}});                          //
// Sandstorm - Personal Cloud Sandbox                                                                                  // 1
// Copyright (c) 2015 Sandstorm Development Group, Inc. and contributors                                               // 2
// All rights reserved.                                                                                                // 3
//                                                                                                                     // 4
// Licensed under the Apache License, Version 2.0 (the "License");                                                     // 5
// you may not use this file except in compliance with the License.                                                    // 6
// You may obtain a copy of the License at                                                                             // 7
//                                                                                                                     // 8
//   http://www.apache.org/licenses/LICENSE-2.0                                                                        // 9
//                                                                                                                     // 10
// Unless required by applicable law or agreed to in writing, software                                                 // 11
// distributed under the License is distributed on an "AS IS" BASIS,                                                   // 12
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.                                            // 13
// See the License for the specific language governing permissions and                                                 // 14
// limitations under the License.                                                                                      // 15
                                                                                                                       //
var makeIdenticon = void 0;                                                                                            // 17
var httpProtocol = void 0;                                                                                             // 18
                                                                                                                       //
if (Meteor.isServer) {                                                                                                 // 20
  SandstormDb.ensureSubscriberHasIdentity = function (publishHandler, identityId) {                                    // 21
    // Helper for publish functions that need to restrict access based on whether the subscriber                       // 22
    // has a given identity linked. Automatically stops the subscription if the user loses the                         // 23
    // identity. Returns a boolean indicating whether the user initially has the identity.                             // 24
                                                                                                                       //
    var userId = publishHandler.userId;                                                                                // 26
    if (userId === identityId) {                                                                                       // 27
      return true;                                                                                                     // 28
    } else {                                                                                                           // 29
      var _ret = function () {                                                                                         // 29
        var hasIdentityCursor = Meteor.users.find({                                                                    // 30
          $or: [{                                                                                                      // 31
            _id: userId,                                                                                               // 33
            "loginIdentities.id": identityId                                                                           // 34
          }, {                                                                                                         // 32
            _id: userId,                                                                                               // 37
            "nonloginIdentities.id": identityId                                                                        // 38
          }]                                                                                                           // 36
        });                                                                                                            // 30
        if (hasIdentityCursor.count() == 0) {                                                                          // 42
          publishHandler.stop();                                                                                       // 43
          return {                                                                                                     // 44
            v: false                                                                                                   // 44
          };                                                                                                           // 44
        }                                                                                                              // 45
                                                                                                                       //
        var handle = hasIdentityCursor.observe({ removed: function () {                                                // 47
            function removed() {                                                                                       // 47
              publishHandler.stop();                                                                                   // 47
            }                                                                                                          // 47
                                                                                                                       //
            return removed;                                                                                            // 47
          }() });                                                                                                      // 47
                                                                                                                       //
        publishHandler.onStop(function () {                                                                            // 49
          handle.stop();                                                                                               // 49
        });                                                                                                            // 49
                                                                                                                       //
        return {                                                                                                       // 51
          v: true                                                                                                      // 51
        };                                                                                                             // 51
      }();                                                                                                             // 29
                                                                                                                       //
      if ((typeof _ret === "undefined" ? "undefined" : _typeof(_ret)) === "object") return _ret.v;                     // 29
    }                                                                                                                  // 52
  };                                                                                                                   // 53
                                                                                                                       //
  Meteor.publish("identityProfile", function (identityId) {                                                            // 55
    check(identityId, String);                                                                                         // 56
    if (!SandstormDb.ensureSubscriberHasIdentity(this, identityId)) return;                                            // 57
                                                                                                                       //
    return Meteor.users.find({ _id: identityId }, { fields: {                                                          // 59
        profile: 1,                                                                                                    // 61
        unverifiedEmail: 1,                                                                                            // 62
        expires: 1,                                                                                                    // 63
        createdAt: 1,                                                                                                  // 64
                                                                                                                       //
        "services.dev.name": 1,                                                                                        // 66
                                                                                                                       //
        "services.google.id": 1,                                                                                       // 68
        "services.google.email": 1,                                                                                    // 69
        "services.google.verified_email": 1,                                                                           // 70
        "services.google.name": 1,                                                                                     // 71
        "services.google.picture": 1,                                                                                  // 72
        "services.google.gender": 1,                                                                                   // 73
        "services.google.hd": 1,                                                                                       // 74
                                                                                                                       //
        "services.github.id": 1,                                                                                       // 76
        "services.github.email": 1,                                                                                    // 77
        "services.github.emails": 1,                                                                                   // 78
        "services.github.username": 1,                                                                                 // 79
                                                                                                                       //
        "services.email.email": 1,                                                                                     // 81
                                                                                                                       //
        "services.ldap.id": 1,                                                                                         // 83
        "services.ldap.username": 1,                                                                                   // 84
        "services.ldap.rawAttrs": 1,                                                                                   // 85
                                                                                                                       //
        "services.saml.id": 1,                                                                                         // 87
        "services.saml.email": 1,                                                                                      // 88
        "services.saml.displayName": 1                                                                                 // 89
      }                                                                                                                // 60
    });                                                                                                                // 60
  }), Meteor.publish("accountIdentities", function () {                                                                // 92
    // Maybe this should be folded into the "credentials" subscription?                                                // 95
                                                                                                                       //
    if (!this.userId) return [];                                                                                       // 97
                                                                                                                       //
    return Meteor.users.find({ _id: this.userId }, { fields: {                                                         // 99
        profile: 1,                                                                                                    // 102
        verifiedEmail: 1,                                                                                              // 103
        loginIdentities: 1,                                                                                            // 104
        nonloginIdentities: 1,                                                                                         // 105
        expires: 1,                                                                                                    // 106
        primaryEmail: 1                                                                                                // 107
      } });                                                                                                            // 101
  });                                                                                                                  // 109
                                                                                                                       //
  makeIdenticon = function makeIdenticon(id) {                                                                         // 111
    var hash = id.slice(0, 32);                                                                                        // 112
    return httpProtocol + "//" + makeWildcardHost("static") + "/identicon/" + hash + "?s=256";                         // 113
  };                                                                                                                   // 114
                                                                                                                       //
  var Url = Npm.require("url");                                                                                        // 116
  httpProtocol = Url.parse(process.env.ROOT_URL).protocol;                                                             // 117
} else {                                                                                                               // 118
  (function () {                                                                                                       // 118
    var identiconCache = {};                                                                                           // 119
                                                                                                                       //
    makeIdenticon = function makeIdenticon(id) {                                                                       // 121
      // Given a cryptographic hash as input, generate an identicon. We always use the user's                          // 122
      // identity ID as the input hash (the same thing passed to apps as the user ID).                                 // 123
                                                                                                                       //
      // Pass to identicon.js exactly the hash that we'd pass to apps as X-Sandstorm-User-Id, so                       // 125
      // that apps can themselves use identicon.js to produce consistent identicons. As it turns out                   // 126
      // identicon.js doesn't use the second half of the hash even if we provide it, but slice it                      // 127
      // anyway to be safe.                                                                                            // 128
      var hash = id.slice(0, 32);                                                                                      // 129
                                                                                                                       //
      if (hash in identiconCache) {                                                                                    // 131
        return identiconCache[hash];                                                                                   // 132
      }                                                                                                                // 133
                                                                                                                       //
      // Unfortunately, Github's algorithm uses MD5. Whatever, we don't expect these to be secure.                     // 135
      var data = new Identicon(hash, 512).toString();                                                                  // 136
      var result = "data:image/svg+xml," + encodeURIComponent(data);                                                   // 137
      identiconCache[hash] = result;                                                                                   // 138
      return result;                                                                                                   // 139
    };                                                                                                                 // 140
                                                                                                                       //
    httpProtocol = window.location.protocol;                                                                           // 142
  })();                                                                                                                // 118
}                                                                                                                      // 143
                                                                                                                       //
var GENDERS = { male: "male", female: "female", neutral: "neutral", robot: "robot" };                                  // 145
                                                                                                                       //
function staticAssetUrl(id, staticHost) {                                                                              // 147
  if (id) {                                                                                                            // 148
    return staticHost + "/" + id;                                                                                      // 149
  } else {                                                                                                             // 150
    return undefined;                                                                                                  // 151
  }                                                                                                                    // 152
}                                                                                                                      // 153
                                                                                                                       //
function filterHandle(handle) {                                                                                        // 155
  // Convert disallowed letters into underscores, but no more than one underscore in a row.                            // 156
  return handle && handle.toLowerCase().split(/[^a-z0-9_]+/g).join("_");                                               // 157
}                                                                                                                      // 158
                                                                                                                       //
function emailToHandle(email) {                                                                                        // 160
  // Turn an email address into a handle.                                                                              // 161
                                                                                                                       //
  if (!email) return undefined;                                                                                        // 163
                                                                                                                       //
  // Use the stuff before the @. Ignore stuff after '+' because it's commonly used for filters                         // 165
  // on the same account.                                                                                              // 166
  var parts = email.split("@");                                                                                        // 167
  var base = filterHandle(parts[0].split("+")[0]);                                                                     // 168
                                                                                                                       //
  var domain = (parts[1] || "").split(".");                                                                            // 170
  if (domain[domain.length - 1] === "name") {                                                                          // 171
    // Oh, a .name domain. Let's use                                                                                   // 172
    base = filterHandle(domain.slice(0, domain.length - 1).join("."));                                                 // 173
  } else if (_.contains(["me", "self", "contact", "admin", "administrator", "root", "info", "sandstorm", "sandstormio", "inbox", "indiegogo", "mail", "email"], base)) {
    // This is probably an address at a vanity domain. Use the domain itself as the handle.                            // 180
    base = filterHandle(domain[0]);                                                                                    // 181
  }                                                                                                                    // 182
                                                                                                                       //
  return filterHandle(base);                                                                                           // 184
}                                                                                                                      // 185
                                                                                                                       //
SandstormDb.fillInProfileDefaults = function (user) {                                                                  // 187
  var profile = user.profile;                                                                                          // 188
  if (profile.service === "github") {                                                                                  // 189
    profile.name = profile.name || user.services.github.username || "Name Unknown";                                    // 190
    profile.handle = profile.handle || filterHandle(user.services.github.username) || filterHandle(profile.name);      // 191
  } else if (profile.service === "google") {                                                                           // 193
    profile.name = profile.name || user.services.google.name || "Name Unknown";                                        // 194
    profile.handle = profile.handle || emailToHandle(user.services.google.email) || filterHandle(profile.name);        // 195
    profile.pronoun = profile.pronoun || GENDERS[user.services.google.gender] || "neutral";                            // 197
  } else if (profile.service === "email") {                                                                            // 198
    var email = user.services.email.email;                                                                             // 199
    profile.name = profile.name || emailToHandle(email);                                                               // 200
    profile.handle = profile.handle || emailToHandle(email);                                                           // 201
  } else if (profile.service === "dev") {                                                                              // 202
    var lowerCaseName = user.services.dev.name.split(" ")[0].toLowerCase();                                            // 203
    profile.name = profile.name || user.services.dev.name;                                                             // 204
    profile.handle = profile.handle || filterHandle(lowerCaseName);                                                    // 205
    profile.pronoun = profile.pronoun || (_.contains(["alice", "carol", "eve"], lowerCaseName) ? "female" : _.contains(["bob", "dave"], lowerCaseName) ? "male" : "neutral");
  } else if (profile.service === "demo") {                                                                             // 209
    profile.name = profile.name || "Demo User";                                                                        // 210
    profile.handle = profile.handle || "demo";                                                                         // 211
  } else if (profile.service === "ldap") {                                                                             // 212
    var setting = Settings.findOne({ _id: "ldapNameField" });                                                          // 213
    var key = setting ? setting.value : "";                                                                            // 214
    profile.handle = profile.handle || user.services.ldap.username;                                                    // 215
    profile.name = profile.name || user.services.ldap.rawAttrs[key] || profile.handle;                                 // 216
  } else if (profile.service === "saml") {                                                                             // 217
    profile.handle = profile.handle || emailToHandle(user.services.saml.email);                                        // 218
    profile.name = profile.name || user.services.saml.displayName || profile.handle;                                   // 219
  } else {                                                                                                             // 220
    throw new Error("unrecognized identity service: ", profile.service);                                               // 221
  }                                                                                                                    // 222
                                                                                                                       //
  profile.pronoun = profile.pronoun || "neutral";                                                                      // 224
};                                                                                                                     // 225
                                                                                                                       //
SandstormDb.fillInIntrinsicName = function (user) {                                                                    // 227
  var profile = user.profile;                                                                                          // 228
  if (profile.service === "github") {                                                                                  // 229
    profile.intrinsicName = user.services.github.username;                                                             // 230
  } else if (profile.service === "google") {                                                                           // 231
    profile.intrinsicName = user.services.google.name;                                                                 // 232
    user.privateIntrinsicName = user.services.google.email;                                                            // 233
  } else if (profile.service === "email") {                                                                            // 234
    profile.intrinsicName = user.services.email.email;                                                                 // 235
  } else if (profile.service === "dev") {                                                                              // 236
    profile.intrinsicName = user.services.dev.name;                                                                    // 237
  } else if (profile.service === "demo") {                                                                             // 238
    profile.intrinsicName = "demo on " + user.createdAt.toISOString().substring(0, 10);                                // 239
  } else if (profile.service === "ldap") {                                                                             // 240
    profile.intrinsicName = user.services.ldap.username;                                                               // 241
  } else if (profile.service === "saml") {                                                                             // 242
    profile.intrinsicName = user.services.saml.id;                                                                     // 243
  } else {                                                                                                             // 244
    throw new Error("unrecognized identity service: ", profile.service);                                               // 245
  }                                                                                                                    // 246
};                                                                                                                     // 247
                                                                                                                       //
SandstormDb.fillInLoginId = function (identity) {                                                                      // 249
  var service = identity.profile.service;                                                                              // 250
  identity.loginId = Accounts.identityServices[service].getLoginId(identity);                                          // 251
};                                                                                                                     // 252
                                                                                                                       //
SandstormDb.getVerifiedEmails = function (identity) {                                                                  // 254
  if (identity.services.google && identity.services.google.email && identity.services.google.verified_email) {         // 255
    // jscs:ignore requireCamelCaseOrUpperCaseIdentifiers                                                              // 256
    return [{ email: identity.services.google.email, primary: true }];                                                 // 257
  } else if (identity.services.email) {                                                                                // 258
    return [{ email: identity.services.email.email, primary: true }];                                                  // 259
  } else if (identity.services.github && identity.services.github.emails) {                                            // 260
    return _.chain(identity.services.github.emails).filter(function (email) {                                          // 261
      return email.verified;                                                                                           // 262
    }).map(function (email) {                                                                                          // 262
      return _.pick(email, "email", "primary");                                                                        // 263
    }).value();                                                                                                        // 263
  } else if (identity.services.ldap) {                                                                                 // 265
    // TODO(cleanup): don't create a new SandstormDb here, make this non-static                                        // 266
    var email = identity.services.ldap.rawAttrs[new SandstormDb().getLdapEmailField()];                                // 267
    if (email) {                                                                                                       // 268
      return [{ email: email, primary: true }];                                                                        // 269
    }                                                                                                                  // 270
  } else if (identity.services.saml && identity.services.saml.email) {                                                 // 271
    return [{ email: identity.services.saml.email, primary: true }];                                                   // 272
  }                                                                                                                    // 273
                                                                                                                       //
  return [];                                                                                                           // 275
};                                                                                                                     // 276
                                                                                                                       //
SandstormDb.prototype.findIdentitiesByEmail = function (email) {                                                       // 278
  // Returns an array of identities which have the given email address as one of their verified                        // 279
  // addresses.                                                                                                        // 280
                                                                                                                       //
  check(email, String);                                                                                                // 282
                                                                                                                       //
  // For LDAP, the field containing the e-mail address is configurable...                                              // 284
  var ldapQuery = {};                                                                                                  // 285
  ldapQuery["services.ldap.rawAttrs." + this.getLdapEmailField()] = email;                                             // 286
                                                                                                                       //
  return Meteor.users.find({ $or: [{ "services.google.email": email }, { "services.email.email": email }, { "services.github.emails.email": email }, ldapQuery, { "services.saml.email": email }] }).fetch().filter(function (identity) {
    // Verify that the email is verified, since our query doesn't technically do that.                                 // 295
    return !!_.findWhere(SandstormDb.getVerifiedEmails(identity), { email: email });                                   // 296
  });                                                                                                                  // 297
};                                                                                                                     // 298
                                                                                                                       //
SandstormDb.prototype.findAccountsByEmail = function (email) {                                                         // 300
  var identityIds = _.pluck(this.findIdentitiesByEmail(email), "_id");                                                 // 301
  return Meteor.users.find({ $or: [{ "loginIdentities.id": { $in: identityIds } }, { "nonloginIdentities.id": { $in: identityIds } }] }).fetch();
};                                                                                                                     // 306
                                                                                                                       //
SandstormDb.fillInPictureUrl = function (user) {                                                                       // 308
  var staticHost = httpProtocol + "//" + makeWildcardHost("static");                                                   // 309
  user.profile.pictureUrl = staticAssetUrl(user.profile.picture, staticHost) || makeIdenticon(user._id);               // 310
};                                                                                                                     // 312
                                                                                                                       //
SandstormDb.getUserIdentityIds = function (user) {                                                                     // 314
  // Given an account user object, returns an array containing the ID of each identity linked to the                   // 315
  // account. Always returns the most recently added login identity first.                                             // 316
  if (user && user.loginIdentities) {                                                                                  // 317
    return _.pluck(user.nonloginIdentities.concat(user.loginIdentities), "id").reverse();                              // 318
  } else {                                                                                                             // 319
    return [];                                                                                                         // 320
  }                                                                                                                    // 321
};                                                                                                                     // 322
                                                                                                                       //
SandstormDb.getUserEmails = function (user) {                                                                          // 324
  // Given a user object, returns an array containing all email addresses associated with that user.                   // 325
  // Each entry in the array is an object of the form:                                                                 // 326
  //     `{email: String, verified: Bool, primary: Optional(Bool)}`                                                    // 327
  //                                                                                                                   // 328
  // At most one entry in the result has `primary = true`.                                                             // 329
  //                                                                                                                   // 330
  // TODO(cleanup): This actually does need to query the database to fetch profile information                         // 331
  //   for linked identities, so it probably makes more sense for it to be a non-static method                         // 332
  //   on SandstormDb.                                                                                                 // 333
                                                                                                                       //
  var identityIds = SandstormDb.getUserIdentityIds(user);                                                              // 335
  var verifiedEmails = {};                                                                                             // 336
  var unverifiedEmails = {};                                                                                           // 337
                                                                                                                       //
  identityIds.forEach(function (id) {                                                                                  // 339
    var identity = Meteor.users.findOne({ _id: id });                                                                  // 340
    if (identity && identity.services) {                                                                               // 341
      SandstormDb.getVerifiedEmails(identity).forEach(function (verifiedEmail) {                                       // 342
        if (verifiedEmail) {                                                                                           // 343
          verifiedEmails[verifiedEmail.email] = true;                                                                  // 344
        }                                                                                                              // 345
      });                                                                                                              // 346
    }                                                                                                                  // 347
                                                                                                                       //
    if (identity && identity.unverifiedEmail) {                                                                        // 349
      unverifiedEmails[identity.unverifiedEmail] = true;                                                               // 350
    }                                                                                                                  // 351
  });                                                                                                                  // 352
                                                                                                                       //
  var result = [];                                                                                                     // 354
  _.keys(verifiedEmails).map(function (email) {                                                                        // 355
    result.push({ email: email,                                                                                        // 356
      verified: true,                                                                                                  // 357
      primary: email === user.primaryEmail });                                                                         // 358
  });                                                                                                                  // 359
                                                                                                                       //
  _.keys(unverifiedEmails).map(function (email) {                                                                      // 361
    if (!(email in verifiedEmails)) {                                                                                  // 362
      result.push({ email: email, verified: false });                                                                  // 362
    }                                                                                                                  // 362
  });                                                                                                                  // 363
                                                                                                                       //
  // If `user.primaryEmail` is not among the verified emails, mark the first as primary.                               // 365
  if (!(user.primaryEmail in verifiedEmails) && result.length > 0) {                                                   // 366
    result[0].primary = true;                                                                                          // 367
  }                                                                                                                    // 368
                                                                                                                       //
  return result;                                                                                                       // 370
};                                                                                                                     // 371
                                                                                                                       //
SandstormDb.prototype.addContact = function () {                                                                       // 373
  function addContact(ownerId, identityId) {                                                                           // 373
    check(ownerId, String);                                                                                            // 374
    check(identityId, String);                                                                                         // 375
    var profile = this.getIdentity(identityId).profile;                                                                // 376
    this.collections.contacts.upsert({ ownerId: ownerId, identityId: identityId }, {                                   // 377
      ownerId: ownerId,                                                                                                // 378
      petname: profile && profile.name,                                                                                // 379
      created: new Date(),                                                                                             // 380
      identityId: identityId                                                                                           // 381
    });                                                                                                                // 377
  }                                                                                                                    // 383
                                                                                                                       //
  return addContact;                                                                                                   // 373
}();                                                                                                                   // 373
/////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

}]}}}},{"extensions":[".js",".json"]});
require("./node_modules/meteor/sandstorm-db/db.js");
require("./node_modules/meteor/sandstorm-db/profile.js");

/* Exports */
if (typeof Package === 'undefined') Package = {};
(function (pkg, symbols) {
  for (var s in symbols)
    (s in pkg) || (pkg[s] = symbols[s]);
})(Package['sandstorm-db'] = {}, {
  SandstormDb: SandstormDb
});

})();

//# sourceMappingURL=sandstorm-db.js.map
